package org.omg.FT;

//
// Helper class for : CallLogRecordAS
//
// @author OpenORB Compiler
//
public class CallLogRecordASHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert CallLogRecordAS into an any
	// @param	a an any
	// @param	t CallLogRecordAS value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.CallLogRecordAS t )
	{
		a.insert_Streamable( new org.omg.FT.CallLogRecordASHolder( t ));
	}

	//
	// Extract CallLogRecordAS from an any
	// @param	a an any
	// @return the extracted CallLogRecordAS value
	//
	public static org.omg.FT.CallLogRecordAS extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.CallLogRecordASHolder)
					return ((org.omg.FT.CallLogRecordASHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.CallLogRecordASHolder h = new org.omg.FT.CallLogRecordASHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the CallLogRecordAS TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[4];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "call_rec";
				_members[0].type = org.omg.FT.CallLogRecordHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "buffer";
				_members[1].type = org.omg.FT.BytearrHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "bigEndian";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "version";
				_members[3].type = org.omg.GIOP.VersionHelper.type();
				_tc = orb.create_struct_tc(id(),"CallLogRecordAS",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the CallLogRecordAS IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/CallLogRecordAS:1.0";

	//
	// Read CallLogRecordAS from a marshalled stream
	// @param	istream the input stream
	// @return the readed CallLogRecordAS value
	//
	public static org.omg.FT.CallLogRecordAS read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.CallLogRecordAS new_one = new org.omg.FT.CallLogRecordAS();

		new_one.call_rec = org.omg.FT.CallLogRecordHelper.read(istream);
		new_one.buffer = org.omg.FT.BytearrHelper.read(istream);
		new_one.bigEndian = istream.read_boolean();
		new_one.version = org.omg.GIOP.VersionHelper.read(istream);

		return new_one;
	}

	//
	// Write CallLogRecordAS into a marshalled stream
	// @param	ostream the output stream
	// @param	value CallLogRecordAS value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.CallLogRecordAS value )
	{
		org.omg.FT.CallLogRecordHelper.write(ostream,value.call_rec);
		org.omg.FT.BytearrHelper.write(ostream,value.buffer);
		ostream.write_boolean(value.bigEndian);
		org.omg.GIOP.VersionHelper.write(ostream,value.version);
	}

}
