package org.omg.FT;

//
// Helper class for : CheckpointIntervalValue
//
// @author OpenORB Compiler
//
public class CheckpointIntervalValueHelper
{
	//
	// Insert CheckpointIntervalValue into an any
	// @param	a an any
	// @param	t CheckpointIntervalValue value
	//
	public static void insert( org.omg.CORBA.Any a, long t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract CheckpointIntervalValue from an any
	// @param	a an any
	// @return the extracted CheckpointIntervalValue value
	//
	public static long extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the CheckpointIntervalValue TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"CheckpointIntervalValue",org.omg.TimeBase.TimeTHelper.type());
		}
		return _tc;
	}

	//
	// Return the CheckpointIntervalValue IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/CheckpointIntervalValue:1.0";

	//
	// Read CheckpointIntervalValue from a marshalled stream
	// @param	istream the input stream
	// @return the readed CheckpointIntervalValue value
	//
	public static long read( org.omg.CORBA.portable.InputStream istream )
	{
		long new_one;
		new_one = istream.read_ulonglong();

		return new_one;
	}

	//
	// Write CheckpointIntervalValue into a marshalled stream
	// @param	ostream the output stream
	// @param	value CheckpointIntervalValue value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, long value )
	{
		ostream.write_ulonglong(value);
	}

}
