package org.omg.FT;

//
// Interface definition : Checkpointable
//
// @author OpenORB Compiler
//
public class CheckpointablePOATie extends CheckpointablePOA
{

	//
	// Private reference to implementation object
	//
	private CheckpointableOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public CheckpointablePOATie( CheckpointableOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public CheckpointablePOATie( CheckpointableOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public CheckpointableOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( CheckpointableOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation get_state
	//
	public byte[] get_state()
		throws org.omg.FT.NoStateAvailable
	{
		return _tie.get_state();
	}

	//
	// Operation set_state
	//
	public void set_state(byte[] s)
		throws org.omg.FT.InvalidState
	{
		_tie.set_state( s);
	}

}
