package org.omg.FT;

//
// Helper class for : FTFailNotRelServiceContext
//
// @author OpenORB Compiler
//
public class FTFailNotRelServiceContextHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FTFailNotRelServiceContext into an any
	// @param	a an any
	// @param	t FTFailNotRelServiceContext value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FTFailNotRelServiceContext t )
	{
		a.insert_Streamable( new org.omg.FT.FTFailNotRelServiceContextHolder( t ));
	}

	//
	// Extract FTFailNotRelServiceContext from an any
	// @param	a an any
	// @return the extracted FTFailNotRelServiceContext value
	//
	public static org.omg.FT.FTFailNotRelServiceContext extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FTFailNotRelServiceContextHolder)
					return ((org.omg.FT.FTFailNotRelServiceContextHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FTFailNotRelServiceContextHolder h = new org.omg.FT.FTFailNotRelServiceContextHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FTFailNotRelServiceContext TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "group_view_nr";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "membership";
				_members[1].type = org.omg.IOP.IORHelper.type();
				_tc = orb.create_struct_tc(id(),"FTFailNotRelServiceContext",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FTFailNotRelServiceContext IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FTFailNotRelServiceContext:1.0";

	//
	// Read FTFailNotRelServiceContext from a marshalled stream
	// @param	istream the input stream
	// @return the readed FTFailNotRelServiceContext value
	//
	public static org.omg.FT.FTFailNotRelServiceContext read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FTFailNotRelServiceContext new_one = new org.omg.FT.FTFailNotRelServiceContext();

		new_one.group_view_nr = istream.read_long();
		new_one.membership = org.omg.IOP.IORHelper.read(istream);

		return new_one;
	}

	//
	// Write FTFailNotRelServiceContext into a marshalled stream
	// @param	ostream the output stream
	// @param	value FTFailNotRelServiceContext value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FTFailNotRelServiceContext value )
	{
		ostream.write_long(value.group_view_nr);
		org.omg.IOP.IORHelper.write(ostream,value.membership);
	}

}
