package org.omg.FT;

//
// Helper class for : FTRelTotOrdBrServiceContext
//
// @author OpenORB Compiler
//
public class FTRelTotOrdBrServiceContextHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FTRelTotOrdBrServiceContext into an any
	// @param	a an any
	// @param	t FTRelTotOrdBrServiceContext value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FTRelTotOrdBrServiceContext t )
	{
		a.insert_Streamable( new org.omg.FT.FTRelTotOrdBrServiceContextHolder( t ));
	}

	//
	// Extract FTRelTotOrdBrServiceContext from an any
	// @param	a an any
	// @return the extracted FTRelTotOrdBrServiceContext value
	//
	public static org.omg.FT.FTRelTotOrdBrServiceContext extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FTRelTotOrdBrServiceContextHolder)
					return ((org.omg.FT.FTRelTotOrdBrServiceContextHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FTRelTotOrdBrServiceContextHolder h = new org.omg.FT.FTRelTotOrdBrServiceContextHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FTRelTotOrdBrServiceContext TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "tot_ord_req_id";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "sender";
				_members[1].type = org.omg.IOP.IORHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "members_ior";
				_members[2].type = org.omg.IOP.IORHelper.type();
				_tc = orb.create_struct_tc(id(),"FTRelTotOrdBrServiceContext",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FTRelTotOrdBrServiceContext IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FTRelTotOrdBrServiceContext:1.0";

	//
	// Read FTRelTotOrdBrServiceContext from a marshalled stream
	// @param	istream the input stream
	// @return the readed FTRelTotOrdBrServiceContext value
	//
	public static org.omg.FT.FTRelTotOrdBrServiceContext read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FTRelTotOrdBrServiceContext new_one = new org.omg.FT.FTRelTotOrdBrServiceContext();

		new_one.tot_ord_req_id = istream.read_long();
		new_one.sender = org.omg.IOP.IORHelper.read(istream);
		new_one.members_ior = org.omg.IOP.IORHelper.read(istream);

		return new_one;
	}

	//
	// Write FTRelTotOrdBrServiceContext into a marshalled stream
	// @param	ostream the output stream
	// @param	value FTRelTotOrdBrServiceContext value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FTRelTotOrdBrServiceContext value )
	{
		ostream.write_long(value.tot_ord_req_id);
		org.omg.IOP.IORHelper.write(ostream,value.sender);
		org.omg.IOP.IORHelper.write(ostream,value.members_ior);
	}

}
