package org.omg.FT;

//
// Helper class for : FaultMonitorInfo
//
// @author OpenORB Compiler
//
public class FaultMonitorInfoHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FaultMonitorInfo into an any
	// @param	a an any
	// @param	t FaultMonitorInfo value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FaultMonitorInfo t )
	{
		a.insert_Streamable( new org.omg.FT.FaultMonitorInfoHolder( t ));
	}

	//
	// Extract FaultMonitorInfo from an any
	// @param	a an any
	// @return the extracted FaultMonitorInfo value
	//
	public static org.omg.FT.FaultMonitorInfo extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FaultMonitorInfoHolder)
					return ((org.omg.FT.FaultMonitorInfoHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FaultMonitorInfoHolder h = new org.omg.FT.FaultMonitorInfoHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FaultMonitorInfo TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "the_monitor";
				_members[0].type = org.omg.FT.FaultMonitorHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "the_location";
				_members[1].type = org.omg.FT.LocationHelper.type();
				_tc = orb.create_struct_tc(id(),"FaultMonitorInfo",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FaultMonitorInfo IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultMonitorInfo:1.0";

	//
	// Read FaultMonitorInfo from a marshalled stream
	// @param	istream the input stream
	// @return the readed FaultMonitorInfo value
	//
	public static org.omg.FT.FaultMonitorInfo read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FaultMonitorInfo new_one = new org.omg.FT.FaultMonitorInfo();

		new_one.the_monitor = org.omg.FT.FaultMonitorHelper.read(istream);
		new_one.the_location = org.omg.FT.LocationHelper.read(istream);

		return new_one;
	}

	//
	// Write FaultMonitorInfo into a marshalled stream
	// @param	ostream the output stream
	// @param	value FaultMonitorInfo value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FaultMonitorInfo value )
	{
		org.omg.FT.FaultMonitorHelper.write(ostream,value.the_monitor);
		org.omg.FT.LocationHelper.write(ostream,value.the_location);
	}

}
