package org.omg.FT;

//
// Interface definition : FaultMonitor
//
// @author OpenORB Compiler
//
public abstract class FaultMonitorPOA extends org.omg.PortableServer.Servant
		implements FaultMonitorOperations, org.omg.CORBA.portable.InvokeHandler
{
	public FaultMonitor _this()
	{
		return FaultMonitorHelper.narrow(_this_object());
	}

	public FaultMonitor _this( org.omg.CORBA.ORB orb )
	{
		return FaultMonitorHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/FaultMonitor:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("do_monitor") )
		{
			org.omg.FT.PullMonitorable arg0_in = org.omg.FT.PullMonitorableHelper.read(_is);
			long arg1_in = _is.read_longlong();
			int arg2_in = _is.read_long();
			org.omg.FT.FaultMonitoringIntervalAndTimeoutValue arg3_in = org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHelper.read(_is);

			do_monitor(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		else
		if ( opName.equals("stop_monitor") )
		{
			org.omg.CORBA.Object arg0_in = _is.read_Object();

			stop_monitor(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
