package org.omg.FT;

//
// Interface definition : FaultMonitor
//
// @author OpenORB Compiler
//
public class FaultMonitorPOATie extends FaultMonitorPOA
{

	//
	// Private reference to implementation object
	//
	private FaultMonitorOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public FaultMonitorPOATie( FaultMonitorOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public FaultMonitorPOATie( FaultMonitorOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public FaultMonitorOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( FaultMonitorOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation do_monitor
	//
	public void do_monitor(org.omg.FT.PullMonitorable obj, long o_g_id, int f_m_gran, org.omg.FT.FaultMonitoringIntervalAndTimeoutValue fmiv)
	{
		_tie.do_monitor( obj,  o_g_id,  f_m_gran,  fmiv);
	}

	//
	// Operation stop_monitor
	//
	public void stop_monitor(org.omg.CORBA.Object obj)
	{
		_tie.stop_monitor( obj);
	}

}
