package org.omg.FT;

//
// Helper class for : FaultMonitorThreadAttribs
//
// @author OpenORB Compiler
//
public class FaultMonitorThreadAttribsHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FaultMonitorThreadAttribs into an any
	// @param	a an any
	// @param	t FaultMonitorThreadAttribs value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FaultMonitorThreadAttribs t )
	{
		a.insert_Streamable( new org.omg.FT.FaultMonitorThreadAttribsHolder( t ));
	}

	//
	// Extract FaultMonitorThreadAttribs from an any
	// @param	a an any
	// @return the extracted FaultMonitorThreadAttribs value
	//
	public static org.omg.FT.FaultMonitorThreadAttribs extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FaultMonitorThreadAttribsHolder)
					return ((org.omg.FT.FaultMonitorThreadAttribsHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FaultMonitorThreadAttribsHolder h = new org.omg.FT.FaultMonitorThreadAttribsHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FaultMonitorThreadAttribs TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "monit_gran";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "obj_gr_id";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "fmiv";
				_members[2].type = org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHelper.type();
				_tc = orb.create_struct_tc(id(),"FaultMonitorThreadAttribs",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FaultMonitorThreadAttribs IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultMonitorThreadAttribs:1.0";

	//
	// Read FaultMonitorThreadAttribs from a marshalled stream
	// @param	istream the input stream
	// @return the readed FaultMonitorThreadAttribs value
	//
	public static org.omg.FT.FaultMonitorThreadAttribs read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FaultMonitorThreadAttribs new_one = new org.omg.FT.FaultMonitorThreadAttribs();

		new_one.monit_gran = istream.read_long();
		new_one.obj_gr_id = istream.read_longlong();
		new_one.fmiv = org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHelper.read(istream);

		return new_one;
	}

	//
	// Write FaultMonitorThreadAttribs into a marshalled stream
	// @param	ostream the output stream
	// @param	value FaultMonitorThreadAttribs value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FaultMonitorThreadAttribs value )
	{
		ostream.write_long(value.monit_gran);
		ostream.write_longlong(value.obj_gr_id);
		org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHelper.write(ostream,value.fmiv);
	}

}
