package org.omg.FT;

//
// Helper class for : FaultMonitoringIntervalAndTimeoutValue
//
// @author OpenORB Compiler
//
public class FaultMonitoringIntervalAndTimeoutValueHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FaultMonitoringIntervalAndTimeoutValue into an any
	// @param	a an any
	// @param	t FaultMonitoringIntervalAndTimeoutValue value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FaultMonitoringIntervalAndTimeoutValue t )
	{
		a.insert_Streamable( new org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHolder( t ));
	}

	//
	// Extract FaultMonitoringIntervalAndTimeoutValue from an any
	// @param	a an any
	// @return the extracted FaultMonitoringIntervalAndTimeoutValue value
	//
	public static org.omg.FT.FaultMonitoringIntervalAndTimeoutValue extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHolder)
					return ((org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHolder h = new org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FaultMonitoringIntervalAndTimeoutValue TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "monitoring_interval";
				_members[0].type = org.omg.TimeBase.TimeTHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "timeout";
				_members[1].type = org.omg.TimeBase.TimeTHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "a";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_short);
				_tc = orb.create_struct_tc(id(),"FaultMonitoringIntervalAndTimeoutValue",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FaultMonitoringIntervalAndTimeoutValue IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultMonitoringIntervalAndTimeoutValue:1.0";

	//
	// Read FaultMonitoringIntervalAndTimeoutValue from a marshalled stream
	// @param	istream the input stream
	// @return the readed FaultMonitoringIntervalAndTimeoutValue value
	//
	public static org.omg.FT.FaultMonitoringIntervalAndTimeoutValue read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FaultMonitoringIntervalAndTimeoutValue new_one = new org.omg.FT.FaultMonitoringIntervalAndTimeoutValue();

		new_one.monitoring_interval = org.omg.TimeBase.TimeTHelper.read(istream);
		new_one.timeout = org.omg.TimeBase.TimeTHelper.read(istream);
		new_one.a = istream.read_short();

		return new_one;
	}

	//
	// Write FaultMonitoringIntervalAndTimeoutValue into a marshalled stream
	// @param	ostream the output stream
	// @param	value FaultMonitoringIntervalAndTimeoutValue value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FaultMonitoringIntervalAndTimeoutValue value )
	{
		org.omg.TimeBase.TimeTHelper.write(ostream,value.monitoring_interval);
		org.omg.TimeBase.TimeTHelper.write(ostream,value.timeout);
		ostream.write_short(value.a);
	}

}
