package org.omg.FT;

//
// Interface definition : FaultNotifier
//
// @author OpenORB Compiler
//
public interface FaultNotifierOperations
{
	//
	// Operation push_structured_fault
	//
	public void push_structured_fault(org.omg.CosNotification.StructuredEvent event);

	//
	// Operation push_sequence_fault
	//
	public void push_sequence_fault(org.omg.CosNotification.StructuredEvent[] events);

	//
	// Operation create_subscription_filter
	//
	public org.omg.CosNotifyFilter.Filter create_subscription_filter(String constraint_grammar)
		throws org.omg.CosNotifyFilter.InvalidGrammar;

	//
	// Operation connect_structured_fault_consumer
	//
	public long connect_structured_fault_consumer(org.omg.CosNotifyComm.StructuredPushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter);

	//
	// Operation connect_sequence_fault_consumer
	//
	public long connect_sequence_fault_consumer(org.omg.CosNotifyComm.SequencePushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter);

	//
	// Operation disconnect_consumer
	//
	public void disconnect_consumer(long connection)
		throws org.omg.CosEventComm.Disconnected;

}
