package org.omg.FT;

//
// Interface definition : FaultNotifier
//
// @author OpenORB Compiler
//
public abstract class FaultNotifierPOA extends org.omg.PortableServer.Servant
		implements FaultNotifierOperations, org.omg.CORBA.portable.InvokeHandler
{
	public FaultNotifier _this()
	{
		return FaultNotifierHelper.narrow(_this_object());
	}

	public FaultNotifier _this( org.omg.CORBA.ORB orb )
	{
		return FaultNotifierHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/FaultNotifier:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("push_structured_fault") )
		{
			org.omg.CosNotification.StructuredEvent arg0_in = org.omg.CosNotification.StructuredEventHelper.read(_is);

			push_structured_fault(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		else
		if ( opName.equals("push_sequence_fault") )
		{
			org.omg.CosNotification.StructuredEvent[] arg0_in = org.omg.CosNotification.EventBatchHelper.read(_is);

			push_sequence_fault(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		else
		if ( opName.equals("create_subscription_filter") )
		{
			String arg0_in = _is.read_string();

			try
			{
				org.omg.CosNotifyFilter.Filter _arg_result = create_subscription_filter(arg0_in);

				_output = handler.createReply();
				org.omg.CosNotifyFilter.FilterHelper.write(_output,_arg_result);

			}
			catch ( org.omg.CosNotifyFilter.InvalidGrammar _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.CosNotifyFilter.InvalidGrammarHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("connect_structured_fault_consumer") )
		{
			org.omg.CosNotifyComm.StructuredPushConsumer arg0_in = org.omg.CosNotifyComm.StructuredPushConsumerHelper.read(_is);
			org.omg.CosNotifyFilter.Filter arg1_in = org.omg.CosNotifyFilter.FilterHelper.read(_is);

			long _arg_result = connect_structured_fault_consumer(arg0_in, arg1_in);

			_output = handler.createReply();
			org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.write(_output,_arg_result);

			return _output;
		}
		else
		if ( opName.equals("connect_sequence_fault_consumer") )
		{
			org.omg.CosNotifyComm.SequencePushConsumer arg0_in = org.omg.CosNotifyComm.SequencePushConsumerHelper.read(_is);
			org.omg.CosNotifyFilter.Filter arg1_in = org.omg.CosNotifyFilter.FilterHelper.read(_is);

			long _arg_result = connect_sequence_fault_consumer(arg0_in, arg1_in);

			_output = handler.createReply();
			org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.write(_output,_arg_result);

			return _output;
		}
		else
		if ( opName.equals("disconnect_consumer") )
		{
			long arg0_in = org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.read(_is);

			try
			{
				disconnect_consumer(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.CosEventComm.Disconnected _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.CosEventComm.DisconnectedHelper.write(_output,_exception);
			}
			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
