package org.omg.FT;

//
// Interface definition : FaultNotifier
//
// @author OpenORB Compiler
//
public class FaultNotifierPOATie extends FaultNotifierPOA
{

	//
	// Private reference to implementation object
	//
	private FaultNotifierOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public FaultNotifierPOATie( FaultNotifierOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public FaultNotifierPOATie( FaultNotifierOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public FaultNotifierOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( FaultNotifierOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation push_structured_fault
	//
	public void push_structured_fault(org.omg.CosNotification.StructuredEvent event)
	{
		_tie.push_structured_fault( event);
	}

	//
	// Operation push_sequence_fault
	//
	public void push_sequence_fault(org.omg.CosNotification.StructuredEvent[] events)
	{
		_tie.push_sequence_fault( events);
	}

	//
	// Operation create_subscription_filter
	//
	public org.omg.CosNotifyFilter.Filter create_subscription_filter(String constraint_grammar)
		throws org.omg.CosNotifyFilter.InvalidGrammar
	{
		return _tie.create_subscription_filter( constraint_grammar);
	}

	//
	// Operation connect_structured_fault_consumer
	//
	public long connect_structured_fault_consumer(org.omg.CosNotifyComm.StructuredPushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter)
	{
		return _tie.connect_structured_fault_consumer( push_consumer,  filter);
	}

	//
	// Operation connect_sequence_fault_consumer
	//
	public long connect_sequence_fault_consumer(org.omg.CosNotifyComm.SequencePushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter)
	{
		return _tie.connect_sequence_fault_consumer( push_consumer,  filter);
	}

	//
	// Operation disconnect_consumer
	//
	public void disconnect_consumer(long connection)
		throws org.omg.CosEventComm.Disconnected
	{
		_tie.disconnect_consumer( connection);
	}

}
