package org.omg.FT.FaultNotifierPackage;

//
// Helper class for : ConsumerId
//
// @author OpenORB Compiler
//
public class ConsumerIdHelper
{
	//
	// Insert ConsumerId into an any
	// @param	a an any
	// @param	t ConsumerId value
	//
	public static void insert( org.omg.CORBA.Any a, long t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract ConsumerId from an any
	// @param	a an any
	// @return the extracted ConsumerId value
	//
	public static long extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the ConsumerId TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"ConsumerId",orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulonglong));
		}
		return _tc;
	}

	//
	// Return the ConsumerId IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultNotifier/ConsumerId:1.0";

	//
	// Read ConsumerId from a marshalled stream
	// @param	istream the input stream
	// @return the readed ConsumerId value
	//
	public static long read( org.omg.CORBA.portable.InputStream istream )
	{
		long new_one;
		new_one = istream.read_ulonglong();

		return new_one;
	}

	//
	// Write ConsumerId into a marshalled stream
	// @param	ostream the output stream
	// @param	value ConsumerId value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, long value )
	{
		ostream.write_ulonglong(value);
	}

}
