package org.omg.FT;

//
// Interface definition : GatewayForActiveRepl
//
// @author OpenORB Compiler
//
public class GatewayForActiveReplPOATie extends GatewayForActiveReplPOA
{

	//
	// Private reference to implementation object
	//
	private GatewayForActiveReplOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public GatewayForActiveReplPOATie( GatewayForActiveReplOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public GatewayForActiveReplPOATie( GatewayForActiveReplOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public GatewayForActiveReplOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( GatewayForActiveReplOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation invoke
	//
	public org.omg.CORBA.Any invoke(org.omg.CORBA.Object target, String type_id, int ret_id, String client_id, long req_start_time, String oper, org.omg.FT.ParametersHolder args, org.omg.CORBA.TypeCode[] exc, boolean resp_exp, org.omg.CORBA.Any result)
	{
		return _tie.invoke( target,  type_id,  ret_id,  client_id,  req_start_time,  oper,  args,  exc,  resp_exp,  result);
	}

	//
	// Operation init_membership
	//
	public void init_membership(org.omg.FT.ObjectLocStr[] members)
	{
		_tie.init_membership( members);
	}

	//
	// Operation change_membership
	//
	public void change_membership(org.omg.CORBA.Object[] new_memb, String[] location)
	{
		_tie.change_membership( new_memb,  location);
	}

	//
	// Operation group_members
	//
	public org.omg.CORBA.Object[] group_members()
	{
		return _tie.group_members();
	}

}
