package org.omg.FT;

//
// Helper class for : GenericFactory
//
// @author OpenORB Compiler
//
public class GenericFactoryHelper
{
	//
	// Insert GenericFactory into an any
	// @param	a an any
	// @param	t GenericFactory value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.GenericFactory t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract GenericFactory from an any
	// @param	a an any
	// @return the extracted GenericFactory value
	//
	public static org.omg.FT.GenericFactory extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.GenericFactoryHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the GenericFactory TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"GenericFactory");
		}
		return _tc;
	}

	//
	// Return the GenericFactory IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/GenericFactory:1.0";

	//
	// Read GenericFactory from a marshalled stream
	// @param	istream the input stream
	// @return the readed GenericFactory value
	//
	public static org.omg.FT.GenericFactory read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.GenericFactory )istream.read_Object( org.omg.FT._GenericFactoryStub.class );
	}

	//
	// Write GenericFactory into a marshalled stream
	// @param	ostream the output stream
	// @param	value GenericFactory value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.GenericFactory value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to GenericFactory
	// @param	obj the CORBA Object
	// @return GenericFactory Object
	//
	public static GenericFactory narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof GenericFactory )
			return ( GenericFactory)obj;

		if ( obj._is_a( id() ) )
		{
			_GenericFactoryStub stub = new _GenericFactoryStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to GenericFactory
	// @param	obj the CORBA Object
	// @return GenericFactory Object
	//
	public static GenericFactory unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof GenericFactory )
			return ( GenericFactory)obj;

		_GenericFactoryStub stub = new _GenericFactoryStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
