package org.omg.FT.GenericFactoryPackage;

//
// Helper class for : FactoryCreationId
//
// @author OpenORB Compiler
//
public class FactoryCreationIdHelper
{
	//
	// Insert FactoryCreationId into an any
	// @param	a an any
	// @param	t FactoryCreationId value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.CORBA.Any t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract FactoryCreationId from an any
	// @param	a an any
	// @return the extracted FactoryCreationId value
	//
	public static org.omg.CORBA.Any extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the FactoryCreationId TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"FactoryCreationId",orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any));
		}
		return _tc;
	}

	//
	// Return the FactoryCreationId IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/GenericFactory/FactoryCreationId:1.0";

	//
	// Read FactoryCreationId from a marshalled stream
	// @param	istream the input stream
	// @return the readed FactoryCreationId value
	//
	public static org.omg.CORBA.Any read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.CORBA.Any new_one;
		new_one = istream.read_any();

		return new_one;
	}

	//
	// Write FactoryCreationId into a marshalled stream
	// @param	ostream the output stream
	// @param	value FactoryCreationId value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.CORBA.Any value )
	{
		ostream.write_any(value);
	}

}
