package org.omg.FT;

//
// Helper class for : HeartbeatEnabledPolicy
//
// @author OpenORB Compiler
//
public class HeartbeatEnabledPolicyHelper
{
	//
	// Insert HeartbeatEnabledPolicy into an any
	// @param	a an any
	// @param	t HeartbeatEnabledPolicy value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.HeartbeatEnabledPolicy t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract HeartbeatEnabledPolicy from an any
	// @param	a an any
	// @return the extracted HeartbeatEnabledPolicy value
	//
	public static org.omg.FT.HeartbeatEnabledPolicy extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.HeartbeatEnabledPolicyHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the HeartbeatEnabledPolicy TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"HeartbeatEnabledPolicy");
		}
		return _tc;
	}

	//
	// Return the HeartbeatEnabledPolicy IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/HeartbeatEnabledPolicy:1.0";

	//
	// Read HeartbeatEnabledPolicy from a marshalled stream
	// @param	istream the input stream
	// @return the readed HeartbeatEnabledPolicy value
	//
	public static org.omg.FT.HeartbeatEnabledPolicy read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.HeartbeatEnabledPolicy )istream.read_Object( org.omg.FT._HeartbeatEnabledPolicyStub.class );
	}

	//
	// Write HeartbeatEnabledPolicy into a marshalled stream
	// @param	ostream the output stream
	// @param	value HeartbeatEnabledPolicy value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.HeartbeatEnabledPolicy value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to HeartbeatEnabledPolicy
	// @param	obj the CORBA Object
	// @return HeartbeatEnabledPolicy Object
	//
	public static HeartbeatEnabledPolicy narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof HeartbeatEnabledPolicy )
			return ( HeartbeatEnabledPolicy)obj;

		if ( obj._is_a( id() ) )
		{
			_HeartbeatEnabledPolicyStub stub = new _HeartbeatEnabledPolicyStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to HeartbeatEnabledPolicy
	// @param	obj the CORBA Object
	// @return HeartbeatEnabledPolicy Object
	//
	public static HeartbeatEnabledPolicy unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof HeartbeatEnabledPolicy )
			return ( HeartbeatEnabledPolicy)obj;

		_HeartbeatEnabledPolicyStub stub = new _HeartbeatEnabledPolicyStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
