package org.omg.FT;

//
// Interface definition : HeartbeatEnabledPolicy
//
// @author OpenORB Compiler
//
public class HeartbeatEnabledPolicyPOATie extends HeartbeatEnabledPolicyPOA
{

	//
	// Private reference to implementation object
	//
	private HeartbeatEnabledPolicyOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public HeartbeatEnabledPolicyPOATie( HeartbeatEnabledPolicyOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public HeartbeatEnabledPolicyPOATie( HeartbeatEnabledPolicyOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public HeartbeatEnabledPolicyOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( HeartbeatEnabledPolicyOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Read accessor for heartbeat_enabled_policy_value attribute
	//
	public boolean heartbeat_enabled_policy_value()
	{
		return _tie.heartbeat_enabled_policy_value();
	}

	//
	// Read accessor for policy_type attribute
	//
	public int policy_type()
	{
		return _tie.policy_type();
	}

	//
	// Operation copy
	//
	public org.omg.CORBA.Policy copy()
	{
		return _tie.copy();
	}

	//
	// Operation destroy
	//
	public void destroy()
	{
		_tie.destroy();
	}

}
