package org.omg.FT;

//
// Helper class for : InvalidCriteria
//
// @author OpenORB Compiler
//
public class InvalidCriteriaHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert InvalidCriteria into an any
	// @param	a an any
	// @param	t InvalidCriteria value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.InvalidCriteria t )
	{
		a.insert_Streamable( new org.omg.FT.InvalidCriteriaHolder( t ));
	}

	//
	// Extract InvalidCriteria from an any
	// @param	a an any
	// @return the extracted InvalidCriteria value
	//
	public static org.omg.FT.InvalidCriteria extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.InvalidCriteriaHolder)
					return ((org.omg.FT.InvalidCriteriaHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.InvalidCriteriaHolder h = new org.omg.FT.InvalidCriteriaHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the InvalidCriteria TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[1];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "invalid_criteria";
				_members[0].type = org.omg.FT.CriteriaHelper.type();
				_tc = orb.create_exception_tc(id(),"InvalidCriteria",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the InvalidCriteria IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/InvalidCriteria:1.0";

	//
	// Read InvalidCriteria from a marshalled stream
	// @param	istream the input stream
	// @return the readed InvalidCriteria value
	//
	public static org.omg.FT.InvalidCriteria read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.InvalidCriteria new_one = new org.omg.FT.InvalidCriteria();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();
		new_one.invalid_criteria = org.omg.FT.CriteriaHelper.read(istream);

		return new_one;
	}

	//
	// Write InvalidCriteria into a marshalled stream
	// @param	ostream the output stream
	// @param	value InvalidCriteria value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.InvalidCriteria value )
	{
		ostream.write_string( id() );
		org.omg.FT.CriteriaHelper.write(ostream,value.invalid_criteria);
	}

}
