package org.omg.FT;

//
// Interface definition : LoggingRecoveryController
//
// @author OpenORB Compiler
//
public abstract class LoggingRecoveryControllerPOA extends org.omg.PortableServer.Servant
		implements LoggingRecoveryControllerOperations, org.omg.CORBA.portable.InvokeHandler
{
	public LoggingRecoveryController _this()
	{
		return LoggingRecoveryControllerHelper.narrow(_this_object());
	}

	public LoggingRecoveryController _this( org.omg.CORBA.ORB orb )
	{
		return LoggingRecoveryControllerHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/LoggingRecoveryController:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	private static java.util.Hashtable _ops_Hash = new java.util.Hashtable();
	static {
		_ops_Hash.put("record_part_get_st_upd_reply", new Integer(0) );
		_ops_Hash.put("record_method_call_par", new Integer(4) );
		_ops_Hash.put("record_method_call_as", new Integer(8) );
		_ops_Hash.put("record_reply", new Integer(12) );
		_ops_Hash.put("record_reply_exc", new Integer(16) );
		_ops_Hash.put("react_set_st_upd_reply", new Integer(20) );
		_ops_Hash.put("call_reply", new Integer(24) );
		_ops_Hash.put("request_reply", new Integer(28) );
		_ops_Hash.put("record_request_repl", new Integer(32) );
		_ops_Hash.put("record_reply_stateless", new Integer(36) );
		_ops_Hash.put("do_checkpointing", new Integer(40) );
		_ops_Hash.put("stop_checkpointing", new Integer(44) );
		_ops_Hash.put("do_updating", new Integer(48) );
		_ops_Hash.put("stop_updating", new Integer(52) );
		_ops_Hash.put("set_neighbours", new Integer(56) );
		_ops_Hash.put("replay_last_requests", new Integer(60) );
		_ops_Hash.put("record_replies", new Integer(64) );
		_ops_Hash.put("recover_new_replica_ch", new Integer(68) );
		_ops_Hash.put("recover_new_replica_st_ch", new Integer(72) );
		_ops_Hash.put("recover_new_replica_upd", new Integer(76) );
		_ops_Hash.put("remove_log", new Integer(80) );
		_ops_Hash.put("record_method_no_wait_par", new Integer(84) );
		_ops_Hash.put("record_method_no_wait_as", new Integer(88) );
		_ops_Hash.put("record_reply_no_notify", new Integer(92) );
	};

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		Integer opidx = (Integer)_ops_Hash.get(opName);
		if(opidx == null)
			throw new org.omg.CORBA.BAD_OPERATION();

		switch(opidx.intValue()) {

		case 0:
		{
			long arg0_in = _is.read_longlong();
			int arg1_in = _is.read_long();
			String arg2_in = _is.read_string();

			record_part_get_st_upd_reply(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		case 4:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			org.omg.Dynamic.Parameter[] arg2_in = org.omg.FT.ParametersHelper.read(_is);
			String arg3_in = _is.read_string();
			int arg4_in = _is.read_long();
			long arg5_in = _is.read_longlong();
			char arg6_in = _is.read_char();
			long arg7_in = _is.read_longlong();
			boolean arg8_in = _is.read_boolean();

			org.omg.FT.ResultResultArgs _arg_result = record_method_call_par(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_in, arg7_in, arg8_in);

			_output = handler.createReply();
			org.omg.FT.ResultResultArgsHelper.write(_output,_arg_result);

			return _output;
		}
		case 8:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			byte[] arg2_in = org.omg.FT.BytearrHelper.read(_is);
			boolean arg3_in = _is.read_boolean();
			org.omg.GIOP.Version arg4_in = org.omg.GIOP.VersionHelper.read(_is);
			String arg5_in = _is.read_string();
			int arg6_in = _is.read_long();
			long arg7_in = _is.read_longlong();
			char arg8_in = _is.read_char();
			boolean arg9_in = _is.read_boolean();

			org.omg.FT.ResultResultArgs _arg_result = record_method_call_as(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_in, arg7_in, arg8_in, arg9_in);

			_output = handler.createReply();
			org.omg.FT.ResultResultArgsHelper.write(_output,_arg_result);

			return _output;
		}
		case 12:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();
			org.omg.CORBA.Any arg3_in = _is.read_any();
			org.omg.CORBA.Any[] arg4_in = org.omg.CORBA.AnySeqHelper.read(_is);
			char arg5_in = _is.read_char();
			boolean arg6_in = _is.read_boolean();

			record_reply(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_in);

			_output = handler.createReply();

			return _output;
		}
		case 16:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();
			char arg3_in = _is.read_char();

			record_reply_exc(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 20:
		{
			long arg0_in = _is.read_longlong();

			react_set_st_upd_reply(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 24:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();

			org.omg.FT.ResultResultArgs _arg_result = call_reply(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();
			org.omg.FT.ResultResultArgsHelper.write(_output,_arg_result);

			return _output;
		}
		case 28:
		{
			String arg0_in = _is.read_string();
			int arg1_in = _is.read_long();
			org.omg.CORBA.Object arg2_in = _is.read_Object();

			org.omg.FT.ResultResultArgs _arg_result = request_reply(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();
			org.omg.FT.ResultResultArgsHelper.write(_output,_arg_result);

			return _output;
		}
		case 32:
		{
			String arg0_in = _is.read_string();
			org.omg.CORBA.Object arg1_in = _is.read_Object();
			String arg2_in = _is.read_string();
			org.omg.CORBA.Any[] arg3_in = org.omg.CORBA.AnySeqHelper.read(_is);
			int arg4_in = _is.read_long();
			org.omg.CORBA.Any arg5_in = _is.read_any();

			record_request_repl(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 36:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();
			long arg3_in = _is.read_longlong();
			org.omg.CORBA.Any arg4_in = _is.read_any();
			org.omg.CORBA.Any[] arg5_in = org.omg.CORBA.AnySeqHelper.read(_is);

			record_reply_stateless(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 40:
		{
			org.omg.FT.Checkpointable arg0_in = org.omg.FT.CheckpointableHelper.read(_is);
			long arg1_in = _is.read_longlong();
			long arg2_in = _is.read_longlong();
			org.omg.FT.Checkpointable[] arg3_in = org.omg.FT.CheckpointableAHelper.read(_is);
			boolean arg4_in = _is.read_boolean();
			boolean arg5_in = _is.read_boolean();

			do_checkpointing(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 44:
		{
			org.omg.FT.Checkpointable arg0_in = org.omg.FT.CheckpointableHelper.read(_is);

			stop_checkpointing(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 48:
		{
			org.omg.FT.Updateable arg0_in = org.omg.FT.UpdateableHelper.read(_is);
			long arg1_in = _is.read_longlong();
			long arg2_in = _is.read_longlong();
			org.omg.FT.Updateable[] arg3_in = org.omg.FT.UpdateableAHelper.read(_is);
			boolean arg4_in = _is.read_boolean();
			boolean arg5_in = _is.read_boolean();

			do_updating(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 52:
		{
			org.omg.FT.Updateable arg0_in = org.omg.FT.UpdateableHelper.read(_is);

			stop_updating(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 56:
		{
			org.omg.FT.LoggingRecoveryController[] arg0_in = org.omg.FT.LoggingRecoveryMechHelper.read(_is);

			set_neighbours(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 60:
		{
			org.omg.CORBA.Object arg0_in = _is.read_Object();
			org.omg.FT.LogRecord[] arg1_in = org.omg.FT.LogRecordsHelper.read(_is);
			long arg2_in = _is.read_longlong();
			int arg3_in = _is.read_long();
			int arg4_in = _is.read_long();

			replay_last_requests(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 64:
		{
			org.omg.FT.LogRecord[] arg0_in = org.omg.FT.LogRecordsHelper.read(_is);

			record_replies(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 68:
		{
			long arg0_in = _is.read_longlong();
			org.omg.FT.LoggingRecoveryController arg1_in = org.omg.FT.LoggingRecoveryControllerHelper.read(_is);
			org.omg.FT.Checkpointable arg2_in = org.omg.FT.CheckpointableHelper.read(_is);
			int arg3_in = _is.read_long();

			recover_new_replica_ch(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 72:
		{
			long arg0_in = _is.read_longlong();
			org.omg.FT.LoggingRecoveryController arg1_in = org.omg.FT.LoggingRecoveryControllerHelper.read(_is);
			org.omg.FT.Checkpointable arg2_in = org.omg.FT.CheckpointableHelper.read(_is);
			org.omg.FT.Checkpointable arg3_in = org.omg.FT.CheckpointableHelper.read(_is);

			recover_new_replica_st_ch(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 76:
		{
			long arg0_in = _is.read_longlong();
			org.omg.FT.LoggingRecoveryController arg1_in = org.omg.FT.LoggingRecoveryControllerHelper.read(_is);
			org.omg.FT.Updateable arg2_in = org.omg.FT.UpdateableHelper.read(_is);
			int arg3_in = _is.read_long();

			recover_new_replica_upd(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 80:
		{
			long arg0_in = _is.read_longlong();

			remove_log(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 84:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			org.omg.Dynamic.Parameter[] arg2_in = org.omg.FT.ParametersHelper.read(_is);
			String arg3_in = _is.read_string();
			int arg4_in = _is.read_long();
			long arg5_in = _is.read_longlong();
			char arg6_in = _is.read_char();
			long arg7_in = _is.read_longlong();

			record_method_no_wait_par(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_in, arg7_in);

			_output = handler.createReply();

			return _output;
		}
		case 88:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			byte[] arg2_in = org.omg.FT.BytearrHelper.read(_is);
			boolean arg3_in = _is.read_boolean();
			org.omg.GIOP.Version arg4_in = org.omg.GIOP.VersionHelper.read(_is);
			String arg5_in = _is.read_string();
			int arg6_in = _is.read_long();
			long arg7_in = _is.read_longlong();
			char arg8_in = _is.read_char();
			long arg9_in = _is.read_longlong();

			record_method_no_wait_as(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_in, arg7_in, arg8_in, arg9_in);

			_output = handler.createReply();

			return _output;
		}
		case 92:
		{
			long arg0_in = _is.read_longlong();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();
			org.omg.CORBA.Any arg3_in = _is.read_any();
			org.omg.CORBA.Any[] arg4_in = org.omg.CORBA.AnySeqHelper.read(_is);
			char arg5_in = _is.read_char();

			record_reply_no_notify(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		}

		// never reached
		throw new org.omg.CORBA.INTERNAL();
	}
}
