package org.omg.FT;

//
// Helper class for : MethSignStr
//
// @author OpenORB Compiler
//
public class MethSignStrHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert MethSignStr into an any
	// @param	a an any
	// @param	t MethSignStr value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.MethSignStr t )
	{
		a.insert_Streamable( new org.omg.FT.MethSignStrHolder( t ));
	}

	//
	// Extract MethSignStr from an any
	// @param	a an any
	// @return the extracted MethSignStr value
	//
	public static org.omg.FT.MethSignStr extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.MethSignStrHolder)
					return ((org.omg.FT.MethSignStrHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.MethSignStrHolder h = new org.omg.FT.MethSignStrHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the MethSignStr TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[5];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "name";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "type";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "param_types";
				_members[2].type = org.omg.FT.TypeCodeSeqHelper.type();
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "param_modes";
				_members[3].type = org.omg.FT.longseqHelper.type();
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "except_types";
				_members[4].type = org.omg.FT.TypeCodeSeqHelper.type();
				_tc = orb.create_struct_tc(id(),"MethSignStr",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the MethSignStr IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/MethSignStr:1.0";

	//
	// Read MethSignStr from a marshalled stream
	// @param	istream the input stream
	// @return the readed MethSignStr value
	//
	public static org.omg.FT.MethSignStr read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.MethSignStr new_one = new org.omg.FT.MethSignStr();

		new_one.name = istream.read_string();
		new_one.type = istream.read_char();
		new_one.param_types = org.omg.FT.TypeCodeSeqHelper.read(istream);
		new_one.param_modes = org.omg.FT.longseqHelper.read(istream);
		new_one.except_types = org.omg.FT.TypeCodeSeqHelper.read(istream);

		return new_one;
	}

	//
	// Write MethSignStr into a marshalled stream
	// @param	ostream the output stream
	// @param	value MethSignStr value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.MethSignStr value )
	{
		ostream.write_string(value.name);
		ostream.write_char(value.type);
		org.omg.FT.TypeCodeSeqHelper.write(ostream,value.param_types);
		org.omg.FT.longseqHelper.write(ostream,value.param_modes);
		org.omg.FT.TypeCodeSeqHelper.write(ostream,value.except_types);
	}

}
