package org.omg.FT;

//
// Helper class for : NoFactory
//
// @author OpenORB Compiler
//
public class NoFactoryHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert NoFactory into an any
	// @param	a an any
	// @param	t NoFactory value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.NoFactory t )
	{
		a.insert_Streamable( new org.omg.FT.NoFactoryHolder( t ));
	}

	//
	// Extract NoFactory from an any
	// @param	a an any
	// @return the extracted NoFactory value
	//
	public static org.omg.FT.NoFactory extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.NoFactoryHolder)
					return ((org.omg.FT.NoFactoryHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.NoFactoryHolder h = new org.omg.FT.NoFactoryHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the NoFactory TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "the_location";
				_members[0].type = org.omg.FT.LocationHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "type_id";
				_members[1].type = org.omg.FT.TypeIdHelper.type();
				_tc = orb.create_exception_tc(id(),"NoFactory",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the NoFactory IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/NoFactory:1.0";

	//
	// Read NoFactory from a marshalled stream
	// @param	istream the input stream
	// @return the readed NoFactory value
	//
	public static org.omg.FT.NoFactory read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.NoFactory new_one = new org.omg.FT.NoFactory();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();
		new_one.the_location = org.omg.FT.LocationHelper.read(istream);
		new_one.type_id = org.omg.FT.TypeIdHelper.read(istream);

		return new_one;
	}

	//
	// Write NoFactory into a marshalled stream
	// @param	ostream the output stream
	// @param	value NoFactory value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.NoFactory value )
	{
		ostream.write_string( id() );
		org.omg.FT.LocationHelper.write(ostream,value.the_location);
		org.omg.FT.TypeIdHelper.write(ostream,value.type_id);
	}

}
