package org.omg.FT;

//
// Helper class for : NoUpdateAvailable
//
// @author OpenORB Compiler
//
public class NoUpdateAvailableHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert NoUpdateAvailable into an any
	// @param	a an any
	// @param	t NoUpdateAvailable value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.NoUpdateAvailable t )
	{
		a.insert_Streamable( new org.omg.FT.NoUpdateAvailableHolder( t ));
	}

	//
	// Extract NoUpdateAvailable from an any
	// @param	a an any
	// @return the extracted NoUpdateAvailable value
	//
	public static org.omg.FT.NoUpdateAvailable extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.NoUpdateAvailableHolder)
					return ((org.omg.FT.NoUpdateAvailableHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.NoUpdateAvailableHolder h = new org.omg.FT.NoUpdateAvailableHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the NoUpdateAvailable TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[0];

				_tc = orb.create_exception_tc(id(),"NoUpdateAvailable",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the NoUpdateAvailable IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/NoUpdateAvailable:1.0";

	//
	// Read NoUpdateAvailable from a marshalled stream
	// @param	istream the input stream
	// @return the readed NoUpdateAvailable value
	//
	public static org.omg.FT.NoUpdateAvailable read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.NoUpdateAvailable new_one = new org.omg.FT.NoUpdateAvailable();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();

		return new_one;
	}

	//
	// Write NoUpdateAvailable into a marshalled stream
	// @param	ostream the output stream
	// @param	value NoUpdateAvailable value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.NoUpdateAvailable value )
	{
		ostream.write_string( id() );
	}

}
