package org.omg.FT;

//
// Helper class for : ObjectGroupManager
//
// @author OpenORB Compiler
//
public class ObjectGroupManagerHelper
{
	//
	// Insert ObjectGroupManager into an any
	// @param	a an any
	// @param	t ObjectGroupManager value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ObjectGroupManager t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract ObjectGroupManager from an any
	// @param	a an any
	// @return the extracted ObjectGroupManager value
	//
	public static org.omg.FT.ObjectGroupManager extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.ObjectGroupManagerHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the ObjectGroupManager TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"ObjectGroupManager");
		}
		return _tc;
	}

	//
	// Return the ObjectGroupManager IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ObjectGroupManager:1.0";

	//
	// Read ObjectGroupManager from a marshalled stream
	// @param	istream the input stream
	// @return the readed ObjectGroupManager value
	//
	public static org.omg.FT.ObjectGroupManager read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.ObjectGroupManager )istream.read_Object( org.omg.FT._ObjectGroupManagerStub.class );
	}

	//
	// Write ObjectGroupManager into a marshalled stream
	// @param	ostream the output stream
	// @param	value ObjectGroupManager value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ObjectGroupManager value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to ObjectGroupManager
	// @param	obj the CORBA Object
	// @return ObjectGroupManager Object
	//
	public static ObjectGroupManager narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ObjectGroupManager )
			return ( ObjectGroupManager)obj;

		if ( obj._is_a( id() ) )
		{
			_ObjectGroupManagerStub stub = new _ObjectGroupManagerStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to ObjectGroupManager
	// @param	obj the CORBA Object
	// @return ObjectGroupManager Object
	//
	public static ObjectGroupManager unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ObjectGroupManager )
			return ( ObjectGroupManager)obj;

		_ObjectGroupManagerStub stub = new _ObjectGroupManagerStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
