package org.omg.FT;

//
// Interface definition : ObjectGroupManager
//
// @author OpenORB Compiler
//
public interface ObjectGroupManagerOperations
{
	//
	// Operation create_member
	//
	public org.omg.CORBA.Object create_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, String type_id, org.omg.FT.Property[] the_criteria)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.CannotMeetCriteria;

	//
	// Operation add_member
	//
	public org.omg.CORBA.Object add_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, org.omg.CORBA.Object member)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.ObjectNotAdded;

	//
	// Operation remove_member
	//
	public org.omg.CORBA.Object remove_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound;

	//
	// Operation set_primary_member
	//
	public org.omg.CORBA.Object set_primary_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound, org.omg.FT.PrimaryNotSet, org.omg.FT.BadReplicationStyle;

	//
	// Operation locations_of_members
	//
	public org.omg.CosNaming.NameComponent[][] locations_of_members(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound;

	//
	// Operation get_object_group_id
	//
	public long get_object_group_id(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound;

	//
	// Operation get_object_group_ref
	//
	public org.omg.CORBA.Object get_object_group_ref(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound;

	//
	// Operation get_group_ref
	//
	public org.omg.CORBA.Object get_group_ref(long group_id);

	//
	// Operation get_member_ref
	//
	public org.omg.CORBA.Object get_member_ref(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] loc)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound;

}
