package org.omg.FT;

//
// Interface definition : ObjectGroupManager
//
// @author OpenORB Compiler
//
public class ObjectGroupManagerPOATie extends ObjectGroupManagerPOA
{

	//
	// Private reference to implementation object
	//
	private ObjectGroupManagerOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public ObjectGroupManagerPOATie( ObjectGroupManagerOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public ObjectGroupManagerPOATie( ObjectGroupManagerOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public ObjectGroupManagerOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( ObjectGroupManagerOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation create_member
	//
	public org.omg.CORBA.Object create_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, String type_id, org.omg.FT.Property[] the_criteria)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.CannotMeetCriteria
	{
		return _tie.create_member( object_group,  the_location,  type_id,  the_criteria);
	}

	//
	// Operation add_member
	//
	public org.omg.CORBA.Object add_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, org.omg.CORBA.Object member)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.ObjectNotAdded
	{
		return _tie.add_member( object_group,  the_location,  member);
	}

	//
	// Operation remove_member
	//
	public org.omg.CORBA.Object remove_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		return _tie.remove_member( object_group,  the_location);
	}

	//
	// Operation set_primary_member
	//
	public org.omg.CORBA.Object set_primary_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound, org.omg.FT.PrimaryNotSet, org.omg.FT.BadReplicationStyle
	{
		return _tie.set_primary_member( object_group,  the_location);
	}

	//
	// Operation locations_of_members
	//
	public org.omg.CosNaming.NameComponent[][] locations_of_members(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.locations_of_members( object_group);
	}

	//
	// Operation get_object_group_id
	//
	public long get_object_group_id(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_object_group_id( object_group);
	}

	//
	// Operation get_object_group_ref
	//
	public org.omg.CORBA.Object get_object_group_ref(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_object_group_ref( object_group);
	}

	//
	// Operation get_group_ref
	//
	public org.omg.CORBA.Object get_group_ref(long group_id)
	{
		return _tie.get_group_ref( group_id);
	}

	//
	// Operation get_member_ref
	//
	public org.omg.CORBA.Object get_member_ref(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] loc)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		return _tie.get_member_ref( object_group,  loc);
	}

}
