package org.omg.FT;

//
// Helper class for : ObjectNotAdded
//
// @author OpenORB Compiler
//
public class ObjectNotAddedHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ObjectNotAdded into an any
	// @param	a an any
	// @param	t ObjectNotAdded value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ObjectNotAdded t )
	{
		a.insert_Streamable( new org.omg.FT.ObjectNotAddedHolder( t ));
	}

	//
	// Extract ObjectNotAdded from an any
	// @param	a an any
	// @return the extracted ObjectNotAdded value
	//
	public static org.omg.FT.ObjectNotAdded extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.ObjectNotAddedHolder)
					return ((org.omg.FT.ObjectNotAddedHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.ObjectNotAddedHolder h = new org.omg.FT.ObjectNotAddedHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ObjectNotAdded TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[0];

				_tc = orb.create_exception_tc(id(),"ObjectNotAdded",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ObjectNotAdded IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ObjectNotAdded:1.0";

	//
	// Read ObjectNotAdded from a marshalled stream
	// @param	istream the input stream
	// @return the readed ObjectNotAdded value
	//
	public static org.omg.FT.ObjectNotAdded read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.ObjectNotAdded new_one = new org.omg.FT.ObjectNotAdded();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();

		return new_one;
	}

	//
	// Write ObjectNotAdded into a marshalled stream
	// @param	ostream the output stream
	// @param	value ObjectNotAdded value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ObjectNotAdded value )
	{
		ostream.write_string( id() );
	}

}
