package org.omg.FT;

//
// Helper class for : PropertyManager
//
// @author OpenORB Compiler
//
public class PropertyManagerHelper
{
	//
	// Insert PropertyManager into an any
	// @param	a an any
	// @param	t PropertyManager value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.PropertyManager t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract PropertyManager from an any
	// @param	a an any
	// @return the extracted PropertyManager value
	//
	public static org.omg.FT.PropertyManager extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.PropertyManagerHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the PropertyManager TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"PropertyManager");
		}
		return _tc;
	}

	//
	// Return the PropertyManager IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/PropertyManager:1.0";

	//
	// Read PropertyManager from a marshalled stream
	// @param	istream the input stream
	// @return the readed PropertyManager value
	//
	public static org.omg.FT.PropertyManager read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.PropertyManager )istream.read_Object( org.omg.FT._PropertyManagerStub.class );
	}

	//
	// Write PropertyManager into a marshalled stream
	// @param	ostream the output stream
	// @param	value PropertyManager value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.PropertyManager value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to PropertyManager
	// @param	obj the CORBA Object
	// @return PropertyManager Object
	//
	public static PropertyManager narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof PropertyManager )
			return ( PropertyManager)obj;

		if ( obj._is_a( id() ) )
		{
			_PropertyManagerStub stub = new _PropertyManagerStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to PropertyManager
	// @param	obj the CORBA Object
	// @return PropertyManager Object
	//
	public static PropertyManager unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof PropertyManager )
			return ( PropertyManager)obj;

		_PropertyManagerStub stub = new _PropertyManagerStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
