package org.omg.FT;

//
// Interface definition : PropertyManager
//
// @author OpenORB Compiler
//
public abstract class PropertyManagerPOA extends org.omg.PortableServer.Servant
		implements PropertyManagerOperations, org.omg.CORBA.portable.InvokeHandler
{
	public PropertyManager _this()
	{
		return PropertyManagerHelper.narrow(_this_object());
	}

	public PropertyManager _this( org.omg.CORBA.ORB orb )
	{
		return PropertyManagerHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/PropertyManager:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("set_default_properties") )
		{
			org.omg.FT.Property[] arg0_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_default_properties(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("get_default_properties") )
		{

			org.omg.FT.Property[] _arg_result = get_default_properties();

			_output = handler.createReply();
			org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			return _output;
		}
		else
		if ( opName.equals("remove_default_properties") )
		{
			org.omg.FT.Property[] arg0_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				remove_default_properties(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("set_type_properties") )
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_type_properties(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("get_type_properties") )
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);

			org.omg.FT.Property[] _arg_result = get_type_properties(arg0_in);

			_output = handler.createReply();
			org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			return _output;
		}
		else
		if ( opName.equals("remove_type_properties") )
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				remove_type_properties(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("set_properties_dynamically") )
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_properties_dynamically(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("get_properties") )
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.FT.Property[] _arg_result = get_properties(arg0_in);

				_output = handler.createReply();
				org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
