package org.omg.FT;

//
// Interface definition : PropertyManager
//
// @author OpenORB Compiler
//
public class PropertyManagerPOATie extends PropertyManagerPOA
{

	//
	// Private reference to implementation object
	//
	private PropertyManagerOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public PropertyManagerPOATie( PropertyManagerOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public PropertyManagerPOATie( PropertyManagerOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public PropertyManagerOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( PropertyManagerOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation set_default_properties
	//
	public void set_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_default_properties( props);
	}

	//
	// Operation get_default_properties
	//
	public org.omg.FT.Property[] get_default_properties()
	{
		return _tie.get_default_properties();
	}

	//
	// Operation remove_default_properties
	//
	public void remove_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.remove_default_properties( props);
	}

	//
	// Operation set_type_properties
	//
	public void set_type_properties(String type_id, org.omg.FT.Property[] overrides)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_type_properties( type_id,  overrides);
	}

	//
	// Operation get_type_properties
	//
	public org.omg.FT.Property[] get_type_properties(String type_id)
	{
		return _tie.get_type_properties( type_id);
	}

	//
	// Operation remove_type_properties
	//
	public void remove_type_properties(String type_id, org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.remove_type_properties( type_id,  props);
	}

	//
	// Operation set_properties_dynamically
	//
	public void set_properties_dynamically(org.omg.CORBA.Object object_group, org.omg.FT.Property[] overrides)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_properties_dynamically( object_group,  overrides);
	}

	//
	// Operation get_properties
	//
	public org.omg.FT.Property[] get_properties(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_properties( object_group);
	}

}
