package org.omg.FT;

//
// Interface definition : PullMonitorable
//
// @author OpenORB Compiler
//
public class PullMonitorablePOATie extends PullMonitorablePOA
{

	//
	// Private reference to implementation object
	//
	private PullMonitorableOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public PullMonitorablePOATie( PullMonitorableOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public PullMonitorablePOATie( PullMonitorableOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public PullMonitorableOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( PullMonitorableOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation is_alive
	//
	public boolean is_alive()
	{
		return _tie.is_alive();
	}

}
