package org.omg.FT;

//
// Helper class for : RecordType
//
// @author OpenORB Compiler
//
public class RecordTypeHelper
{
	//
	// Insert RecordType into an any
	// @param	a an any
	// @param	t RecordType value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.RecordType t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract RecordType from an any
	// @param	a an any
	// @return the extracted RecordType value
	//
	public static org.omg.FT.RecordType extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the RecordType TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			String []_members = new String[7];
			_members[0] = "checkpoint";
			_members[1] = "update";
			_members[2] = "call_par";
			_members[3] = "call_as";
			_members[4] = "reply";
			_members[5] = "request";
			_members[6] = "request_reply";
			_tc = orb.create_enum_tc(id(),"RecordType",_members);
		}
		return _tc;
	}

	//
	// Return the RecordType IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/RecordType:1.0";

	//
	// Read RecordType from a marshalled stream
	// @param	istream the input stream
	// @return the readed RecordType value
	//
	public static org.omg.FT.RecordType read( org.omg.CORBA.portable.InputStream istream )
	{
		return RecordType.from_int(istream.read_ulong());
	}

	//
	// Write RecordType into a marshalled stream
	// @param	ostream the output stream
	// @param	value RecordType value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.RecordType value )
	{
		ostream.write_ulong(value.value());
	}

}
