package org.omg.FT;

//
// Helper class for : ReplicationManager
//
// @author OpenORB Compiler
//
public class ReplicationManagerHelper
{
	//
	// Insert ReplicationManager into an any
	// @param	a an any
	// @param	t ReplicationManager value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ReplicationManager t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract ReplicationManager from an any
	// @param	a an any
	// @return the extracted ReplicationManager value
	//
	public static org.omg.FT.ReplicationManager extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.ReplicationManagerHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the ReplicationManager TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"ReplicationManager");
		}
		return _tc;
	}

	//
	// Return the ReplicationManager IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ReplicationManager:1.0";

	//
	// Read ReplicationManager from a marshalled stream
	// @param	istream the input stream
	// @return the readed ReplicationManager value
	//
	public static org.omg.FT.ReplicationManager read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.ReplicationManager )istream.read_Object( org.omg.FT._ReplicationManagerStub.class );
	}

	//
	// Write ReplicationManager into a marshalled stream
	// @param	ostream the output stream
	// @param	value ReplicationManager value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ReplicationManager value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to ReplicationManager
	// @param	obj the CORBA Object
	// @return ReplicationManager Object
	//
	public static ReplicationManager narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ReplicationManager )
			return ( ReplicationManager)obj;

		if ( obj._is_a( id() ) )
		{
			_ReplicationManagerStub stub = new _ReplicationManagerStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to ReplicationManager
	// @param	obj the CORBA Object
	// @return ReplicationManager Object
	//
	public static ReplicationManager unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ReplicationManager )
			return ( ReplicationManager)obj;

		_ReplicationManagerStub stub = new _ReplicationManagerStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
