package org.omg.FT;

//
// Helper class for : ReplyLogRecord
//
// @author OpenORB Compiler
//
public class ReplyLogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ReplyLogRecord into an any
	// @param	a an any
	// @param	t ReplyLogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ReplyLogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.ReplyLogRecordHolder( t ));
	}

	//
	// Extract ReplyLogRecord from an any
	// @param	a an any
	// @return the extracted ReplyLogRecord value
	//
	public static org.omg.FT.ReplyLogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.ReplyLogRecordHolder)
					return ((org.omg.FT.ReplyLogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.ReplyLogRecordHolder h = new org.omg.FT.ReplyLogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ReplyLogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[6];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "client_id";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "retention_id";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "expiration_time";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "reply";
				_members[3].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "reply_arguments";
				_members[4].type = org.omg.CORBA.AnySeqHelper.type();
				_members[5] = new org.omg.CORBA.StructMember();
				_members[5].name = "type";
				_members[5].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
				_tc = orb.create_struct_tc(id(),"ReplyLogRecord",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ReplyLogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ReplyLogRecord:1.0";

	//
	// Read ReplyLogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed ReplyLogRecord value
	//
	public static org.omg.FT.ReplyLogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.ReplyLogRecord new_one = new org.omg.FT.ReplyLogRecord();

		new_one.client_id = istream.read_string();
		new_one.retention_id = istream.read_long();
		new_one.expiration_time = istream.read_longlong();
		new_one.reply = istream.read_any();
		new_one.reply_arguments = org.omg.CORBA.AnySeqHelper.read(istream);
		new_one.type = istream.read_char();

		return new_one;
	}

	//
	// Write ReplyLogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value ReplyLogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ReplyLogRecord value )
	{
		ostream.write_string(value.client_id);
		ostream.write_long(value.retention_id);
		ostream.write_longlong(value.expiration_time);
		ostream.write_any(value.reply);
		org.omg.CORBA.AnySeqHelper.write(ostream,value.reply_arguments);
		ostream.write_char(value.type);
	}

}
