package org.omg.FT;

//
// Interface definition : RequestDurationPolicy
//
// @author OpenORB Compiler
//
public class RequestDurationPolicyPOATie extends RequestDurationPolicyPOA
{

	//
	// Private reference to implementation object
	//
	private RequestDurationPolicyOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public RequestDurationPolicyPOATie( RequestDurationPolicyOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public RequestDurationPolicyPOATie( RequestDurationPolicyOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public RequestDurationPolicyOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( RequestDurationPolicyOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Read accessor for request_duration_value attribute
	//
	public long request_duration_value()
	{
		return _tie.request_duration_value();
	}

	//
	// Read accessor for policy_type attribute
	//
	public int policy_type()
	{
		return _tie.policy_type();
	}

	//
	// Operation copy
	//
	public org.omg.CORBA.Policy copy()
	{
		return _tie.copy();
	}

	//
	// Operation destroy
	//
	public void destroy()
	{
		_tie.destroy();
	}

}
