package org.omg.FT;

//
// Helper class for : ResultResultArgs
//
// @author OpenORB Compiler
//
public class ResultResultArgsHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ResultResultArgs into an any
	// @param	a an any
	// @param	t ResultResultArgs value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ResultResultArgs t )
	{
		a.insert_Streamable( new org.omg.FT.ResultResultArgsHolder( t ));
	}

	//
	// Extract ResultResultArgs from an any
	// @param	a an any
	// @return the extracted ResultResultArgs value
	//
	public static org.omg.FT.ResultResultArgs extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.ResultResultArgsHolder)
					return ((org.omg.FT.ResultResultArgsHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.ResultResultArgsHolder h = new org.omg.FT.ResultResultArgsHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ResultResultArgs TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "result";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "result_arguments";
				_members[1].type = org.omg.CORBA.AnySeqHelper.type();
				_tc = orb.create_struct_tc(id(),"ResultResultArgs",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ResultResultArgs IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ResultResultArgs:1.0";

	//
	// Read ResultResultArgs from a marshalled stream
	// @param	istream the input stream
	// @return the readed ResultResultArgs value
	//
	public static org.omg.FT.ResultResultArgs read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.ResultResultArgs new_one = new org.omg.FT.ResultResultArgs();

		new_one.result = istream.read_any();
		new_one.result_arguments = org.omg.CORBA.AnySeqHelper.read(istream);

		return new_one;
	}

	//
	// Write ResultResultArgs into a marshalled stream
	// @param	ostream the output stream
	// @param	value ResultResultArgs value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ResultResultArgs value )
	{
		ostream.write_any(value.result);
		org.omg.CORBA.AnySeqHelper.write(ostream,value.result_arguments);
	}

}
