package org.omg.FT;

//
// Helper class for : SomeLogRecord
//
// @author OpenORB Compiler
//
public class SomeLogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert SomeLogRecord into an any
	// @param	a an any
	// @param	t SomeLogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.SomeLogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.SomeLogRecordHolder( t ));
	}

	//
	// Extract SomeLogRecord from an any
	// @param	a an any
	// @return the extracted SomeLogRecord value
	//
	public static org.omg.FT.SomeLogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.SomeLogRecordHolder)
					return ((org.omg.FT.SomeLogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.SomeLogRecordHolder h = new org.omg.FT.SomeLogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the SomeLogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.UnionMember []_members = new org.omg.CORBA.UnionMember[7];
				org.omg.CORBA.Any any;

				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.call_par);
				_members[0] = new org.omg.CORBA.UnionMember();
				_members[0].name = "call_record_par";
				_members[0].label = any;
				_members[0].type = org.omg.FT.CallLogRecordPARHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.call_as);
				_members[1] = new org.omg.CORBA.UnionMember();
				_members[1].name = "call_record_as";
				_members[1].label = any;
				_members[1].type = org.omg.FT.CallLogRecordASHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.reply);
				_members[2] = new org.omg.CORBA.UnionMember();
				_members[2].name = "reply_record";
				_members[2].label = any;
				_members[2].type = org.omg.FT.ReplyLogRecordHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.request);
				_members[3] = new org.omg.CORBA.UnionMember();
				_members[3].name = "request_record";
				_members[3].label = any;
				_members[3].type = org.omg.FT.RequestLogRecordHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.request_reply);
				_members[4] = new org.omg.CORBA.UnionMember();
				_members[4].name = "request_r_record";
				_members[4].label = any;
				_members[4].type = org.omg.FT.RequestReplyLogRecordHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.checkpoint);
				_members[5] = new org.omg.CORBA.UnionMember();
				_members[5].name = "checkp_record";
				_members[5].label = any;
				_members[5].type = org.omg.FT.CheckpointLogRecordHelper.type();
				any = orb.create_any();
				org.omg.FT.RecordTypeHelper.insert(any,org.omg.FT.RecordType.update);
				_members[6] = new org.omg.CORBA.UnionMember();
				_members[6].name = "update_record";
				_members[6].label = any;
				_members[6].type = org.omg.FT.UpdateLogRecordHelper.type();
				_tc = orb.create_union_tc(id(),"SomeLogRecord",org.omg.FT.RecordTypeHelper.type(),_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the SomeLogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/SomeLogRecord:1.0";

	//
	// Read SomeLogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed SomeLogRecord value
	//
	public static org.omg.FT.SomeLogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.SomeLogRecord new_one = new org.omg.FT.SomeLogRecord();

		new_one.__d = org.omg.FT.RecordTypeHelper.read(istream);
		if ( new_one.__d.value() == org.omg.FT.RecordType._call_par )
		{
			new_one._call_record_par = org.omg.FT.CallLogRecordPARHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._call_as )
		{
			new_one._call_record_as = org.omg.FT.CallLogRecordASHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._reply )
		{
			new_one._reply_record = org.omg.FT.ReplyLogRecordHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._request )
		{
			new_one._request_record = org.omg.FT.RequestLogRecordHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._request_reply )
		{
			new_one._request_r_record = org.omg.FT.RequestReplyLogRecordHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._checkpoint )
		{
			new_one._checkp_record = org.omg.FT.CheckpointLogRecordHelper.read(istream);
		}
		else
		if ( new_one.__d.value() == org.omg.FT.RecordType._update )
		{
			new_one._update_record = org.omg.FT.UpdateLogRecordHelper.read(istream);
		}

		return new_one;
	}

	//
	// Write SomeLogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value SomeLogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.SomeLogRecord value )
	{
		org.omg.FT.RecordTypeHelper.write(ostream,value.__d);
		if ( value.__d.value() == org.omg.FT.RecordType._call_par )
		{
			org.omg.FT.CallLogRecordPARHelper.write(ostream,value._call_record_par);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._call_as )
		{
			org.omg.FT.CallLogRecordASHelper.write(ostream,value._call_record_as);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._reply )
		{
			org.omg.FT.ReplyLogRecordHelper.write(ostream,value._reply_record);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._request )
		{
			org.omg.FT.RequestLogRecordHelper.write(ostream,value._request_record);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._request_reply )
		{
			org.omg.FT.RequestReplyLogRecordHelper.write(ostream,value._request_r_record);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._checkpoint )
		{
			org.omg.FT.CheckpointLogRecordHelper.write(ostream,value._checkp_record);
		}
		else
		if ( value.__d.value() == org.omg.FT.RecordType._update )
		{
			org.omg.FT.UpdateLogRecordHelper.write(ostream,value._update_record);
		}
	}

}
