package org.omg.FT;

//
// Holder class for : State
//
// @author OpenORB Compiler
//
final public class StateHolder
		implements org.omg.CORBA.portable.Streamable
{
	//
	// Internal State value
	//
	public byte[] value;

	//
	// Default constructor
	//
	public StateHolder()
	{ }

	//
	// Constructor with value initialisation
	// @param	initial	the initial value
	//
	public StateHolder( byte[] initial )
	{
		value = initial;
	}

	//
	// Read State from a marshalled stream
	// @param	istream the input stream
	//
	public void _read( org.omg.CORBA.portable.InputStream istream )
	{
		value = StateHelper.read(istream);
	}

	//
	// Write State into a marshalled stream
	// @param	ostream the output stream
	//
	public void _write( org.omg.CORBA.portable.OutputStream ostream )
	{
		StateHelper.write(ostream,value);
	}

	//
	// Return the State TypeCode
	// @return a TypeCode
	//
	public org.omg.CORBA.TypeCode _type()
	{
		return StateHelper.type();
	}

}
