package org.omg.FT;

//
// Helper class for : TagFTGroupTaggedComponent
//
// @author OpenORB Compiler
//
public class TagFTGroupTaggedComponentHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert TagFTGroupTaggedComponent into an any
	// @param	a an any
	// @param	t TagFTGroupTaggedComponent value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.TagFTGroupTaggedComponent t )
	{
		a.insert_Streamable( new org.omg.FT.TagFTGroupTaggedComponentHolder( t ));
	}

	//
	// Extract TagFTGroupTaggedComponent from an any
	// @param	a an any
	// @return the extracted TagFTGroupTaggedComponent value
	//
	public static org.omg.FT.TagFTGroupTaggedComponent extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.TagFTGroupTaggedComponentHolder)
					return ((org.omg.FT.TagFTGroupTaggedComponentHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.TagFTGroupTaggedComponentHolder h = new org.omg.FT.TagFTGroupTaggedComponentHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the TagFTGroupTaggedComponent TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[5];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "version";
				_members[0].type = org.omg.GIOP.VersionHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "ft_domain_id";
				_members[1].type = org.omg.FT.FTDomainIdHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "object_group_id";
				_members[2].type = org.omg.FT.ObjectGroupIdHelper.type();
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "object_group_ref_version";
				_members[3].type = org.omg.FT.ObjectGroupRefVersionHelper.type();
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "repl_style";
				_members[4].type = org.omg.FT.ReplicationStyleValueHelper.type();
				_tc = orb.create_struct_tc(id(),"TagFTGroupTaggedComponent",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the TagFTGroupTaggedComponent IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/TagFTGroupTaggedComponent:1.0";

	//
	// Read TagFTGroupTaggedComponent from a marshalled stream
	// @param	istream the input stream
	// @return the readed TagFTGroupTaggedComponent value
	//
	public static org.omg.FT.TagFTGroupTaggedComponent read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.TagFTGroupTaggedComponent new_one = new org.omg.FT.TagFTGroupTaggedComponent();

		new_one.version = org.omg.GIOP.VersionHelper.read(istream);
		new_one.ft_domain_id = org.omg.FT.FTDomainIdHelper.read(istream);
		new_one.object_group_id = org.omg.FT.ObjectGroupIdHelper.read(istream);
		new_one.object_group_ref_version = org.omg.FT.ObjectGroupRefVersionHelper.read(istream);
		new_one.repl_style = org.omg.FT.ReplicationStyleValueHelper.read(istream);

		return new_one;
	}

	//
	// Write TagFTGroupTaggedComponent into a marshalled stream
	// @param	ostream the output stream
	// @param	value TagFTGroupTaggedComponent value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.TagFTGroupTaggedComponent value )
	{
		org.omg.GIOP.VersionHelper.write(ostream,value.version);
		org.omg.FT.FTDomainIdHelper.write(ostream,value.ft_domain_id);
		org.omg.FT.ObjectGroupIdHelper.write(ostream,value.object_group_id);
		org.omg.FT.ObjectGroupRefVersionHelper.write(ostream,value.object_group_ref_version);
		org.omg.FT.ReplicationStyleValueHelper.write(ostream,value.repl_style);
	}

}
