package org.omg.FT;

//
// Interface definition : GenericFactory
//
// @author OpenORB Compiler
//
public class _GenericFactoryStub extends org.omg.CORBA.portable.ObjectImpl
		implements GenericFactory
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/GenericFactory:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.GenericFactoryOperations.class;

	//
	// Operation create_object
	//
	public org.omg.CORBA.Object create_object(String type_id, org.omg.FT.Property[] the_criteria, org.omg.CORBA.AnyHolder factory_creation_id)
		throws org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.InvalidProperty, org.omg.FT.CannotMeetCriteria
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("create_object",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.CriteriaHelper.write(_output,the_criteria);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = _input.read_Object();
					factory_creation_id.value = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.NoFactoryHelper.id()) )
					{
						throw org.omg.FT.NoFactoryHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotCreatedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotCreatedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidCriteriaHelper.id()) )
					{
						throw org.omg.FT.InvalidCriteriaHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.CannotMeetCriteriaHelper.id()) )
					{
						throw org.omg.FT.CannotMeetCriteriaHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("create_object",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					return _self.create_object( type_id,  the_criteria,  factory_creation_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation delete_object
	//
	public void delete_object(org.omg.CORBA.Any factory_creation_id)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("delete_object",true);
					org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,factory_creation_id);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("delete_object",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.delete_object( factory_creation_id);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation activate_object
	//
	public void activate_object(org.omg.CORBA.Any factory_creation_id, long group_id, boolean first_time)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("activate_object",true);
					org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,factory_creation_id);
					_output.write_longlong(group_id);
					_output.write_boolean(first_time);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("activate_object",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.activate_object( factory_creation_id,  group_id,  first_time);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation install_gateway
	//
	public void install_gateway(org.omg.CORBA.Any factory_creation_id, org.omg.CORBA.Object gateway)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("install_gateway",true);
					_output.write_any(factory_creation_id);
					_output.write_Object(gateway);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("install_gateway",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.install_gateway( factory_creation_id,  gateway);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_load
	//
	public int get_load()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_load",true);
					_input = this._invoke(_output);
					int _arg_ret = _input.read_long();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_load",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					return _self.get_load();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_type_id
	//
	public void add_new_type_id(String type_id, String class_name, String[] new_arg_class_n, java.lang.Object[] new_arg_values, org.omg.FT.MethSignStr[] methods)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_type_id",true);
					_output.write_string(type_id);
					_output.write_string(class_name);
					org.omg.CORBA.StringSeqHelper.write(_output,new_arg_class_n);
					org.omg.FT.AbstractBaseSeqHelper.write(_output,new_arg_values);
					org.omg.FT.MethSignStrsHelper.write(_output,methods);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_type_id( type_id,  class_name,  new_arg_class_n,  new_arg_values,  methods);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_type_id
	//
	public void remove_type_id(String type_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_type_id",true);
					_output.write_string(type_id);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.remove_type_id( type_id);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_class_name_ti
	//
	public void modify_class_name_ti(String type_id, String new_class_name)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_class_name_ti",true);
					_output.write_string(type_id);
					_output.write_string(new_class_name);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_class_name_ti",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_class_name_ti( type_id,  new_class_name);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_class_name_ti_ctr
	//
	public void modify_class_name_ti_ctr(String type_id, String new_class_name, String[] class_names, java.lang.Object[] arg_values)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_class_name_ti_ctr",true);
					_output.write_string(type_id);
					_output.write_string(new_class_name);
					org.omg.CORBA.StringSeqHelper.write(_output,class_names);
					org.omg.FT.AbstractBaseSeqHelper.write(_output,arg_values);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_class_name_ti_ctr",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_class_name_ti_ctr( type_id,  new_class_name,  class_names,  arg_values);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_method_type_id_s
	//
	public void add_new_method_type_id_s(String type_id, org.omg.FT.MethSignStr the_method)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_method_type_id_s",true);
					_output.write_string(type_id);
					org.omg.FT.MethSignStrHelper.write(_output,the_method);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_method_type_id_s",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_method_type_id_s( type_id,  the_method);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_method_type_id_d
	//
	public void add_new_method_type_id_d(String type_id, String method_n, org.omg.CORBA.TypeCode[] par_types, org.omg.CORBA.TypeCode[] exc_types, int[] modes, char meth_type)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_method_type_id_d",true);
					_output.write_string(type_id);
					_output.write_string(method_n);
					org.omg.FT.TypeCodeSeqHelper.write(_output,par_types);
					org.omg.FT.TypeCodeSeqHelper.write(_output,exc_types);
					org.omg.FT.longseqHelper.write(_output,modes);
					_output.write_char(meth_type);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_method_type_id_d",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_method_type_id_d( type_id,  method_n,  par_types,  exc_types,  modes,  meth_type);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_method_type_id
	//
	public void remove_method_type_id(String type_id, String the_method)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_method_type_id",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_method_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.remove_method_type_id( type_id,  the_method);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_add_param
	//
	public void modify_meth_type_id_add_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_add_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(par_type);
					_output.write_long(mode);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_add_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_add_param( type_id,  the_method,  par_type,  mode,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_add_exc
	//
	public void modify_meth_type_id_add_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_add_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(exc_type);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_add_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_add_exc( type_id,  the_method,  exc_type,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_remove_param
	//
	public void modify_meth_type_id_remove_param(String type_id, String the_method, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_remove_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_remove_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_remove_param( type_id,  the_method,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_remove_exc
	//
	public void modify_meth_type_id_remove_exc(String type_id, String the_method, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_remove_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_remove_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_remove_exc( type_id,  the_method,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_param
	//
	public void modify_meth_type_id_modify_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(par_type);
					_output.write_long(mode);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_param( type_id,  the_method,  par_type,  mode,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_exc
	//
	public void modify_meth_type_id_modify_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(exc_type);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_exc( type_id,  the_method,  exc_type,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_type
	//
	public void modify_meth_type_id_modify_type(String type_id, String the_method, char new_type)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_type",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_char(new_type);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_type",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_type( type_id,  the_method,  new_type);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
