package org.omg.FT;

//
// Interface definition : ReplicationManager
//
// @author OpenORB Compiler
//
public class _ReplicationManagerStub extends org.omg.CORBA.portable.ObjectImpl
		implements ReplicationManager
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/ReplicationManager:1.0", 
		"IDL:omg.org/FT/PropertyManager:1.0", 
		"IDL:omg.org/FT/ObjectGroupManager:1.0", 
		"IDL:omg.org/FT/GenericFactory:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.ReplicationManagerOperations.class;

	//
	// Operation add_logging_recovery_c
	//
	public void add_logging_recovery_c(org.omg.FT.LoggingRecoveryControllerInfo lrci)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_logging_recovery_c",true);
					org.omg.FT.LoggingRecoveryControllerInfoHelper.write(_output,lrci);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_logging_recovery_c",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ReplicationManagerOperations _self = ( org.omg.FT.ReplicationManagerOperations ) _so.servant;
				try
				{
					_self.add_logging_recovery_c( lrci);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_fault_monitor
	//
	public void add_fault_monitor(org.omg.FT.FaultMonitorInfo fmi)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_fault_monitor",true);
					org.omg.FT.FaultMonitorInfoHelper.write(_output,fmi);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_fault_monitor",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ReplicationManagerOperations _self = ( org.omg.FT.ReplicationManagerOperations ) _so.servant;
				try
				{
					_self.add_fault_monitor( fmi);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation register_fault_notifier
	//
	public void register_fault_notifier(org.omg.FT.FaultNotifier fault_notifier)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("register_fault_notifier",true);
					org.omg.FT.FaultNotifierHelper.write(_output,fault_notifier);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("register_fault_notifier",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ReplicationManagerOperations _self = ( org.omg.FT.ReplicationManagerOperations ) _so.servant;
				try
				{
					_self.register_fault_notifier( fault_notifier);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_fault_notifier
	//
	public org.omg.FT.FaultNotifier get_fault_notifier()
		throws org.omg.FT.InterfaceNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_fault_notifier",true);
					_input = this._invoke(_output);
					org.omg.FT.FaultNotifier _arg_ret = org.omg.FT.FaultNotifierHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InterfaceNotFoundHelper.id()) )
					{
						throw org.omg.FT.InterfaceNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_fault_notifier",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ReplicationManagerOperations _self = ( org.omg.FT.ReplicationManagerOperations ) _so.servant;
				try
				{
					return _self.get_fault_notifier();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_default_properties
	//
	public void set_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_default_properties",true);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_default_properties( props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_default_properties
	//
	public org.omg.FT.Property[] get_default_properties()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_default_properties",true);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_default_properties();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_default_properties
	//
	public void remove_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_default_properties",true);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.remove_default_properties( props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_type_properties
	//
	public void set_type_properties(String type_id, org.omg.FT.Property[] overrides)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.PropertiesHelper.write(_output,overrides);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_type_properties( type_id,  overrides);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_type_properties
	//
	public org.omg.FT.Property[] get_type_properties(String type_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_type_properties( type_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_type_properties
	//
	public void remove_type_properties(String type_id, org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.remove_type_properties( type_id,  props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_properties_dynamically
	//
	public void set_properties_dynamically(org.omg.CORBA.Object object_group, org.omg.FT.Property[] overrides)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_properties_dynamically",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.PropertiesHelper.write(_output,overrides);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_properties_dynamically",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_properties_dynamically( object_group,  overrides);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_properties
	//
	public org.omg.FT.Property[] get_properties(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_properties",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_properties( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation create_member
	//
	public org.omg.CORBA.Object create_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, String type_id, org.omg.FT.Property[] the_criteria)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.CannotMeetCriteria
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("create_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.CriteriaHelper.write(_output,the_criteria);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberAlreadyPresentHelper.id()) )
					{
						throw org.omg.FT.MemberAlreadyPresentHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.NoFactoryHelper.id()) )
					{
						throw org.omg.FT.NoFactoryHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotCreatedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotCreatedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidCriteriaHelper.id()) )
					{
						throw org.omg.FT.InvalidCriteriaHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.CannotMeetCriteriaHelper.id()) )
					{
						throw org.omg.FT.CannotMeetCriteriaHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("create_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.create_member( object_group,  the_location,  type_id,  the_criteria);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_member
	//
	public org.omg.CORBA.Object add_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, org.omg.CORBA.Object member)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.ObjectNotAdded
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_output.write_Object(member);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberAlreadyPresentHelper.id()) )
					{
						throw org.omg.FT.MemberAlreadyPresentHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotAddedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotAddedHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.add_member( object_group,  the_location,  member);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_member
	//
	public org.omg.CORBA.Object remove_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.remove_member( object_group,  the_location);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_primary_member
	//
	public org.omg.CORBA.Object set_primary_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound, org.omg.FT.PrimaryNotSet, org.omg.FT.BadReplicationStyle
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_primary_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.PrimaryNotSetHelper.id()) )
					{
						throw org.omg.FT.PrimaryNotSetHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.BadReplicationStyleHelper.id()) )
					{
						throw org.omg.FT.BadReplicationStyleHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_primary_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.set_primary_member( object_group,  the_location);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation locations_of_members
	//
	public org.omg.CosNaming.NameComponent[][] locations_of_members(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("locations_of_members",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.CosNaming.NameComponent[][] _arg_ret = org.omg.FT.LocationsHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("locations_of_members",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.locations_of_members( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_object_group_id
	//
	public long get_object_group_id(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_object_group_id",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					long _arg_ret = org.omg.FT.ObjectGroupIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_object_group_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_object_group_id( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_object_group_ref
	//
	public org.omg.CORBA.Object get_object_group_ref(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_object_group_ref",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_object_group_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_object_group_ref( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_group_ref
	//
	public org.omg.CORBA.Object get_group_ref(long group_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_group_ref",true);
					org.omg.FT.ObjectGroupIdHelper.write(_output,group_id);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_group_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_group_ref( group_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_member_ref
	//
	public org.omg.CORBA.Object get_member_ref(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] loc)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_member_ref",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,loc);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = _input.read_Object();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_member_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_member_ref( object_group,  loc);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation create_object
	//
	public org.omg.CORBA.Object create_object(String type_id, org.omg.FT.Property[] the_criteria, org.omg.CORBA.AnyHolder factory_creation_id)
		throws org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.InvalidProperty, org.omg.FT.CannotMeetCriteria
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("create_object",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.CriteriaHelper.write(_output,the_criteria);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = _input.read_Object();
					factory_creation_id.value = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
				    System.out.println("REmarshal");
				    _exception.printStackTrace();
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.NoFactoryHelper.id()) )
					{
						throw org.omg.FT.NoFactoryHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotCreatedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotCreatedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidCriteriaHelper.id()) )
					{
						throw org.omg.FT.InvalidCriteriaHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.CannotMeetCriteriaHelper.id()) )
					{
						throw org.omg.FT.CannotMeetCriteriaHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("create_object",_opsClass);
				if ( _so == null ){
				    System.out.println("so null");
				   continue;
				}
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					return _self.create_object( type_id,  the_criteria,  factory_creation_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation delete_object
	//
	public void delete_object(org.omg.CORBA.Any factory_creation_id)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("delete_object",true);
					org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,factory_creation_id);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("delete_object",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.delete_object( factory_creation_id);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation activate_object
	//
	public void activate_object(org.omg.CORBA.Any factory_creation_id, long group_id, boolean first_time)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("activate_object",true);
					org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,factory_creation_id);
					_output.write_longlong(group_id);
					_output.write_boolean(first_time);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("activate_object",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.activate_object( factory_creation_id,  group_id,  first_time);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation install_gateway
	//
	public void install_gateway(org.omg.CORBA.Any factory_creation_id, org.omg.CORBA.Object gateway)
		throws org.omg.FT.ObjectNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("install_gateway",true);
					_output.write_any(factory_creation_id);
					_output.write_Object(gateway);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("install_gateway",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.install_gateway( factory_creation_id,  gateway);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_load
	//
	public int get_load()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_load",true);
					_input = this._invoke(_output);
					int _arg_ret = _input.read_long();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_load",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					return _self.get_load();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_type_id
	//
	public void add_new_type_id(String type_id, String class_name, String[] new_arg_class_n, java.lang.Object[] new_arg_values, org.omg.FT.MethSignStr[] methods)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_type_id",true);
					_output.write_string(type_id);
					_output.write_string(class_name);
					org.omg.CORBA.StringSeqHelper.write(_output,new_arg_class_n);
					org.omg.FT.AbstractBaseSeqHelper.write(_output,new_arg_values);
					org.omg.FT.MethSignStrsHelper.write(_output,methods);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_type_id( type_id,  class_name,  new_arg_class_n,  new_arg_values,  methods);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_type_id
	//
	public void remove_type_id(String type_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_type_id",true);
					_output.write_string(type_id);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.remove_type_id( type_id);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_class_name_ti
	//
	public void modify_class_name_ti(String type_id, String new_class_name)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_class_name_ti",true);
					_output.write_string(type_id);
					_output.write_string(new_class_name);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_class_name_ti",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_class_name_ti( type_id,  new_class_name);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_class_name_ti_ctr
	//
	public void modify_class_name_ti_ctr(String type_id, String new_class_name, String[] class_names, java.lang.Object[] arg_values)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_class_name_ti_ctr",true);
					_output.write_string(type_id);
					_output.write_string(new_class_name);
					org.omg.CORBA.StringSeqHelper.write(_output,class_names);
					org.omg.FT.AbstractBaseSeqHelper.write(_output,arg_values);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_class_name_ti_ctr",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_class_name_ti_ctr( type_id,  new_class_name,  class_names,  arg_values);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_method_type_id_s
	//
	public void add_new_method_type_id_s(String type_id, org.omg.FT.MethSignStr the_method)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_method_type_id_s",true);
					_output.write_string(type_id);
					org.omg.FT.MethSignStrHelper.write(_output,the_method);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_method_type_id_s",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_method_type_id_s( type_id,  the_method);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_new_method_type_id_d
	//
	public void add_new_method_type_id_d(String type_id, String method_n, org.omg.CORBA.TypeCode[] par_types, org.omg.CORBA.TypeCode[] exc_types, int[] modes, char meth_type)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_new_method_type_id_d",true);
					_output.write_string(type_id);
					_output.write_string(method_n);
					org.omg.FT.TypeCodeSeqHelper.write(_output,par_types);
					org.omg.FT.TypeCodeSeqHelper.write(_output,exc_types);
					org.omg.FT.longseqHelper.write(_output,modes);
					_output.write_char(meth_type);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_new_method_type_id_d",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.add_new_method_type_id_d( type_id,  method_n,  par_types,  exc_types,  modes,  meth_type);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_method_type_id
	//
	public void remove_method_type_id(String type_id, String the_method)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_method_type_id",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_method_type_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.remove_method_type_id( type_id,  the_method);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_add_param
	//
	public void modify_meth_type_id_add_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_add_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(par_type);
					_output.write_long(mode);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_add_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_add_param( type_id,  the_method,  par_type,  mode,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_add_exc
	//
	public void modify_meth_type_id_add_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_add_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(exc_type);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_add_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_add_exc( type_id,  the_method,  exc_type,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_remove_param
	//
	public void modify_meth_type_id_remove_param(String type_id, String the_method, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_remove_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_remove_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_remove_param( type_id,  the_method,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_remove_exc
	//
	public void modify_meth_type_id_remove_exc(String type_id, String the_method, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_remove_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_remove_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_remove_exc( type_id,  the_method,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_param
	//
	public void modify_meth_type_id_modify_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_param",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(par_type);
					_output.write_long(mode);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_param",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_param( type_id,  the_method,  par_type,  mode,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_exc
	//
	public void modify_meth_type_id_modify_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_exc",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_TypeCode(exc_type);
					_output.write_long(pos);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_exc",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_exc( type_id,  the_method,  exc_type,  pos);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation modify_meth_type_id_modify_type
	//
	public void modify_meth_type_id_modify_type(String type_id, String the_method, char new_type)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("modify_meth_type_id_modify_type",true);
					_output.write_string(type_id);
					_output.write_string(the_method);
					_output.write_char(new_type);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("modify_meth_type_id_modify_type",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GenericFactoryOperations _self = ( org.omg.FT.GenericFactoryOperations ) _so.servant;
				try
				{
					_self.modify_meth_type_id_modify_type( type_id,  the_method,  new_type);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
