package org.omg.FT;

//
// Interface definition : RequestDurationPolicy
//
// @author OpenORB Compiler
//
public class _RequestDurationPolicyStub extends org.omg.CORBA.portable.ObjectImpl
		implements RequestDurationPolicy
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/RequestDurationPolicy:1.0", 
		"IDL:omg.org/CORBA/Policy:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.RequestDurationPolicyOperations.class;

	//
	// Read accessor for request_duration_value attribute
	// @return	the attribute value
	//
	public long request_duration_value()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_request_duration_value",true);
					_input = this._invoke(_output);
					return org.omg.TimeBase.TimeTHelper.read(_input);
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_request_duration_value",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.RequestDurationPolicyOperations _self = ( org.omg.FT.RequestDurationPolicyOperations ) _so.servant;
				try
				{
					return _self.request_duration_value();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for policy_type attribute
	// @return	the attribute value
	//
	public int policy_type()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_policy_type",true);
					_input = this._invoke(_output);
					return org.omg.CORBA.PolicyTypeHelper.read(_input);
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_policy_type",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CORBA.PolicyOperations _self = ( org.omg.CORBA.PolicyOperations ) _so.servant;
				try
				{
					return _self.policy_type();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation copy
	//
	public org.omg.CORBA.Policy copy()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("copy",true);
					_input = this._invoke(_output);
					org.omg.CORBA.Policy _arg_ret = org.omg.CORBA.PolicyHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("copy",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CORBA.PolicyOperations _self = ( org.omg.CORBA.PolicyOperations ) _so.servant;
				try
				{
					return _self.copy();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation destroy
	//
	public void destroy()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("destroy",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("destroy",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CORBA.PolicyOperations _self = ( org.omg.CORBA.PolicyOperations ) _so.servant;
				try
				{
					_self.destroy();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
