package org.omg.FT;

//
// Helper class for : AbstractBaseSeq
//
// @author OpenORB Compiler
//
public class AbstractBaseSeqHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert AbstractBaseSeq into an any
	// @param	a an any
	// @param	t AbstractBaseSeq value
	//
	public static void insert( org.omg.CORBA.Any a, java.lang.Object[] t )
	{
		a.insert_Streamable( new org.omg.FT.AbstractBaseSeqHolder( t ));
	}

	//
	// Extract AbstractBaseSeq from an any
	// @param	a an any
	// @return the extracted AbstractBaseSeq value
	//
	public static java.lang.Object[] extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.AbstractBaseSeqHolder)
					return ((org.omg.FT.AbstractBaseSeqHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.AbstractBaseSeqHolder h = new org.omg.FT.AbstractBaseSeqHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the AbstractBaseSeq TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"AbstractBaseSeq",orb.create_sequence_tc(0,org.omg.CORBA.AbstractBaseHelper.type()));
		}
		return _tc;
	}

	//
	// Return the AbstractBaseSeq IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/AbstractBaseSeq:1.0";

	//
	// Read AbstractBaseSeq from a marshalled stream
	// @param	istream the input stream
	// @return the readed AbstractBaseSeq value
	//
	public static java.lang.Object[] read( org.omg.CORBA.portable.InputStream istream )
	{
		java.lang.Object[] new_one;
		{
		int size1 = istream.read_ulong();
		new_one = new java.lang.Object[size1];
		for ( int i1=0; i1<new_one.length; i1++)
		 {
			new_one[i1] = org.omg.CORBA.AbstractBaseHelper.read(istream);

		 }
		}

		return new_one;
	}

	//
	// Write AbstractBaseSeq into a marshalled stream
	// @param	ostream the output stream
	// @param	value AbstractBaseSeq value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, java.lang.Object[] value )
	{
		ostream.write_ulong(value.length);
		for ( int i1=0; i1<value.length; i1++)
		{
			org.omg.CORBA.AbstractBaseHelper.write(ostream,value[i1]);

		}
	}

}
