package org.omg.FT;

//
// Helper class for : CallLogRecord
//
// @author OpenORB Compiler
//
public class CallLogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert CallLogRecord into an any
	// @param	a an any
	// @param	t CallLogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.CallLogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.CallLogRecordHolder( t ));
	}

	//
	// Extract CallLogRecord from an any
	// @param	a an any
	// @return the extracted CallLogRecord value
	//
	public static org.omg.FT.CallLogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.CallLogRecordHolder)
					return ((org.omg.FT.CallLogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.CallLogRecordHolder h = new org.omg.FT.CallLogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the CallLogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[6];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "operation";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "client_id";
				_members[1].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "retention_id";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "expiration_time";
				_members[3].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "executing";
				_members[4].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
				_members[5] = new org.omg.CORBA.StructMember();
				_members[5].name = "type";
				_members[5].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
				_tc = orb.create_struct_tc(id(),"CallLogRecord",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the CallLogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/CallLogRecord:1.0";

	//
	// Read CallLogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed CallLogRecord value
	//
	public static org.omg.FT.CallLogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.CallLogRecord new_one = new org.omg.FT.CallLogRecord();

		new_one.operation = istream.read_string();
		new_one.client_id = istream.read_string();
		new_one.retention_id = istream.read_long();
		new_one.expiration_time = istream.read_longlong();
		new_one.executing = istream.read_boolean();
		new_one.type = istream.read_char();

		return new_one;
	}

	//
	// Write CallLogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value CallLogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.CallLogRecord value )
	{
		ostream.write_string(value.operation);
		ostream.write_string(value.client_id);
		ostream.write_long(value.retention_id);
		ostream.write_longlong(value.expiration_time);
		ostream.write_boolean(value.executing);
		ostream.write_char(value.type);
	}

}
