package org.omg.FT;

//
// Helper class for : CallLogRecordPAR
//
// @author OpenORB Compiler
//
public class CallLogRecordPARHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert CallLogRecordPAR into an any
	// @param	a an any
	// @param	t CallLogRecordPAR value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.CallLogRecordPAR t )
	{
		a.insert_Streamable( new org.omg.FT.CallLogRecordPARHolder( t ));
	}

	//
	// Extract CallLogRecordPAR from an any
	// @param	a an any
	// @return the extracted CallLogRecordPAR value
	//
	public static org.omg.FT.CallLogRecordPAR extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.CallLogRecordPARHolder)
					return ((org.omg.FT.CallLogRecordPARHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.CallLogRecordPARHolder h = new org.omg.FT.CallLogRecordPARHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the CallLogRecordPAR TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "call_rec";
				_members[0].type = org.omg.FT.CallLogRecordHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "arguments";
				_members[1].type = org.omg.FT.ParametersHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "timestamp";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_tc = orb.create_struct_tc(id(),"CallLogRecordPAR",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the CallLogRecordPAR IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/CallLogRecordPAR:1.0";

	//
	// Read CallLogRecordPAR from a marshalled stream
	// @param	istream the input stream
	// @return the readed CallLogRecordPAR value
	//
	public static org.omg.FT.CallLogRecordPAR read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.CallLogRecordPAR new_one = new org.omg.FT.CallLogRecordPAR();

		new_one.call_rec = org.omg.FT.CallLogRecordHelper.read(istream);
		new_one.arguments = org.omg.FT.ParametersHelper.read(istream);
		new_one.timestamp = istream.read_longlong();

		return new_one;
	}

	//
	// Write CallLogRecordPAR into a marshalled stream
	// @param	ostream the output stream
	// @param	value CallLogRecordPAR value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.CallLogRecordPAR value )
	{
		org.omg.FT.CallLogRecordHelper.write(ostream,value.call_rec);
		org.omg.FT.ParametersHelper.write(ostream,value.arguments);
		ostream.write_longlong(value.timestamp);
	}

}
