package org.omg.FT;

//
// Helper class for : CheckpointLogRecord
//
// @author OpenORB Compiler
//
public class CheckpointLogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert CheckpointLogRecord into an any
	// @param	a an any
	// @param	t CheckpointLogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.CheckpointLogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.CheckpointLogRecordHolder( t ));
	}

	//
	// Extract CheckpointLogRecord from an any
	// @param	a an any
	// @return the extracted CheckpointLogRecord value
	//
	public static org.omg.FT.CheckpointLogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.CheckpointLogRecordHolder)
					return ((org.omg.FT.CheckpointLogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.CheckpointLogRecordHolder h = new org.omg.FT.CheckpointLogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the CheckpointLogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "state";
				_members[0].type = org.omg.FT.StateHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "timestamp";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "current_retention_id";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_tc = orb.create_struct_tc(id(),"CheckpointLogRecord",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the CheckpointLogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/CheckpointLogRecord:1.0";

	//
	// Read CheckpointLogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed CheckpointLogRecord value
	//
	public static org.omg.FT.CheckpointLogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.CheckpointLogRecord new_one = new org.omg.FT.CheckpointLogRecord();

		new_one.state = org.omg.FT.StateHelper.read(istream);
		new_one.timestamp = istream.read_longlong();
		new_one.current_retention_id = istream.read_long();

		return new_one;
	}

	//
	// Write CheckpointLogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value CheckpointLogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.CheckpointLogRecord value )
	{
		org.omg.FT.StateHelper.write(ostream,value.state);
		ostream.write_longlong(value.timestamp);
		ostream.write_long(value.current_retention_id);
	}

}
