package org.omg.FT;

//
// Helper class for : Checkpointable
//
// @author OpenORB Compiler
//
public class CheckpointableHelper
{
	//
	// Insert Checkpointable into an any
	// @param	a an any
	// @param	t Checkpointable value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.Checkpointable t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract Checkpointable from an any
	// @param	a an any
	// @return the extracted Checkpointable value
	//
	public static org.omg.FT.Checkpointable extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.CheckpointableHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the Checkpointable TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"Checkpointable");
		}
		return _tc;
	}

	//
	// Return the Checkpointable IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/Checkpointable:1.0";

	//
	// Read Checkpointable from a marshalled stream
	// @param	istream the input stream
	// @return the readed Checkpointable value
	//
	public static org.omg.FT.Checkpointable read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.Checkpointable )istream.read_Object( org.omg.FT._CheckpointableStub.class );
	}

	//
	// Write Checkpointable into a marshalled stream
	// @param	ostream the output stream
	// @param	value Checkpointable value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.Checkpointable value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to Checkpointable
	// @param	obj the CORBA Object
	// @return Checkpointable Object
	//
	public static Checkpointable narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Checkpointable )
			return ( Checkpointable)obj;

		if ( obj._is_a( id() ) )
		{
			_CheckpointableStub stub = new _CheckpointableStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to Checkpointable
	// @param	obj the CORBA Object
	// @return Checkpointable Object
	//
	public static Checkpointable unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Checkpointable )
			return ( Checkpointable)obj;

		_CheckpointableStub stub = new _CheckpointableStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
