package org.omg.FT;

//
// Helper class for : FTRequestServiceContext
//
// @author OpenORB Compiler
//
public class FTRequestServiceContextHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FTRequestServiceContext into an any
	// @param	a an any
	// @param	t FTRequestServiceContext value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FTRequestServiceContext t )
	{
		a.insert_Streamable( new org.omg.FT.FTRequestServiceContextHolder( t ));
	}

	//
	// Extract FTRequestServiceContext from an any
	// @param	a an any
	// @return the extracted FTRequestServiceContext value
	//
	public static org.omg.FT.FTRequestServiceContext extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FTRequestServiceContextHolder)
					return ((org.omg.FT.FTRequestServiceContextHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FTRequestServiceContextHolder h = new org.omg.FT.FTRequestServiceContextHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FTRequestServiceContext TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[4];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "client_id";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "retention_id";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "expiration_time";
				_members[2].type = org.omg.TimeBase.TimeTHelper.type();
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "location";
				_members[3].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_tc = orb.create_struct_tc(id(),"FTRequestServiceContext",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FTRequestServiceContext IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FTRequestServiceContext:1.0";

	//
	// Read FTRequestServiceContext from a marshalled stream
	// @param	istream the input stream
	// @return the readed FTRequestServiceContext value
	//
	public static org.omg.FT.FTRequestServiceContext read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FTRequestServiceContext new_one = new org.omg.FT.FTRequestServiceContext();

		new_one.client_id = istream.read_string();
		new_one.retention_id = istream.read_long();
		new_one.expiration_time = org.omg.TimeBase.TimeTHelper.read(istream);
		new_one.location = istream.read_string();

		return new_one;
	}

	//
	// Write FTRequestServiceContext into a marshalled stream
	// @param	ostream the output stream
	// @param	value FTRequestServiceContext value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FTRequestServiceContext value )
	{
		ostream.write_string(value.client_id);
		ostream.write_long(value.retention_id);
		org.omg.TimeBase.TimeTHelper.write(ostream,value.expiration_time);
		ostream.write_string(value.location);
	}

}
