package org.omg.FT;

//
// Helper class for : FactoriesValue
//
// @author OpenORB Compiler
//
public class FactoriesValueHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FactoriesValue into an any
	// @param	a an any
	// @param	t FactoriesValue value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FactoryInfo[] t )
	{
		a.insert_Streamable( new org.omg.FT.FactoriesValueHolder( t ));
	}

	//
	// Extract FactoriesValue from an any
	// @param	a an any
	// @return the extracted FactoriesValue value
	//
	public static org.omg.FT.FactoryInfo[] extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FactoriesValueHolder)
					return ((org.omg.FT.FactoriesValueHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FactoriesValueHolder h = new org.omg.FT.FactoriesValueHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the FactoriesValue TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"FactoriesValue",org.omg.FT.FactoryInfosHelper.type());
		}
		return _tc;
	}

	//
	// Return the FactoriesValue IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FactoriesValue:1.0";

	//
	// Read FactoriesValue from a marshalled stream
	// @param	istream the input stream
	// @return the readed FactoriesValue value
	//
	public static org.omg.FT.FactoryInfo[] read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FactoryInfo[] new_one;
		{
		int size1 = istream.read_ulong();
		new_one = new org.omg.FT.FactoryInfo[size1];
		for ( int i1=0; i1<new_one.length; i1++)
		 {
			new_one[i1] = org.omg.FT.FactoryInfoHelper.read(istream);

		 }
		}

		return new_one;
	}

	//
	// Write FactoriesValue into a marshalled stream
	// @param	ostream the output stream
	// @param	value FactoriesValue value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FactoryInfo[] value )
	{
		ostream.write_ulong(value.length);
		for ( int i1=0; i1<value.length; i1++)
		{
			org.omg.FT.FactoryInfoHelper.write(ostream,value[i1]);

		}
	}

}
