package org.omg.FT;

import org.omg.CosNotifyFilter.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotification.*;
import java.util.*;

public class FaultEventFilter extends FilterPOA{
    
    Vector theConstraints;
    int last_id;
    String constraint_grammar;

    private org.omg.CosNotification.Property[] properties;

    public FaultEventFilter(String c_g){
	last_id=0;
	constraint_grammar=c_g;
	theConstraints=new Vector();
    }

    public ConstraintInfo[] add_constraints(ConstraintExp[] ces) throws InvalidConstraint{
	/* by now, no verificaton about the validity of constraints is done*/
	int i;
	ConstraintInfo[] toRet=new ConstraintInfo[ces.length];

	System.out.println("Add "+ces.length+" constraints");

	for(i=0;i<ces.length;i++){
	    toRet[i]=new ConstraintInfo(ces[i],last_id);
	    theConstraints.addElement(toRet[i]);
	    last_id++;
	}

	System.out.println("Conatraints added");
	//properties=Utils.parse_constraint_expr();
	return toRet;
    }

    public ConstraintInfo[] get_all_constraints(){
	ConstraintInfo[] toRet=new ConstraintInfo[theConstraints.size()];
	toRet = (ConstraintInfo[])theConstraints.toArray(toRet);
	return toRet;
    }   

    public int attach_callback(NotifySubscribe callback){return -1;} 
    public String constraint_grammar(){ return constraint_grammar;} 
    public void destroy(){} 
    public void detach_callback(int callback){}  
    public int[] get_callbacks(){return new int[0];}  
    public ConstraintInfo[] get_constraints(int[] id_list){
	int i,l,j;
	ConstraintInfo crt,toRet[];
	Vector theSel=new Vector();
	l=theConstraints.size();
	for(i=0;i<l;i++){
	    crt=(ConstraintInfo)theConstraints.elementAt(i);
	    for(j=0;j<id_list.length;j++)
		if(crt.constraint_id==id_list[j]){
		    theSel.addElement(crt);
		    break;
		}
	    if(theSel.size()>=id_list.length) break;
	}
	toRet=new ConstraintInfo[theSel.size()];
	toRet=(ConstraintInfo[])theSel.toArray();
	return toRet;
    }

    public boolean match_structured(StructuredEvent filterable_data){return false;} 
    public boolean match_typed(org.omg.CosNotification.Property[] filterable_data) {return false;}
    public boolean match(org.omg.CORBA.Any filterable_data){return false;} 
    public void modify_constraints(int[] del_list, ConstraintInfo[] modify_list){
	int i,j,l;
	ConstraintInfo crt;
	Vector toRem=new Vector();

	l=theConstraints.size();
	
	for(i=0;i<del_list.length;i++)
	    for(j=0;j<l;j++){
		crt=(ConstraintInfo)theConstraints.elementAt(j);
		if(crt.constraint_id==del_list[j])
		    toRem.addElement(crt);
	    }
	l=toRem.size();
	for(i=0;i<l;i++)
	    theConstraints.remove(toRem.elementAt(i));

	l=theConstraints.size();
	for(i=0;i<modify_list.length;i++)
	    for(j=0;j<l;j++){
		crt=(ConstraintInfo)theConstraints.elementAt(j);
		if(crt.constraint_id==modify_list[j].constraint_id)
		    crt.constraint_expression=modify_list[j].constraint_expression;
	    }
    }

    public void remove_all_constraints(){
	theConstraints.clear();
    } 
}
