package org.omg.FT;

//
// Helper class for : FaultMonitor
//
// @author OpenORB Compiler
//
public class FaultMonitorHelper
{
	//
	// Insert FaultMonitor into an any
	// @param	a an any
	// @param	t FaultMonitor value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FaultMonitor t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract FaultMonitor from an any
	// @param	a an any
	// @return the extracted FaultMonitor value
	//
	public static org.omg.FT.FaultMonitor extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.FaultMonitorHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the FaultMonitor TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"FaultMonitor");
		}
		return _tc;
	}

	//
	// Return the FaultMonitor IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultMonitor:1.0";

	//
	// Read FaultMonitor from a marshalled stream
	// @param	istream the input stream
	// @return the readed FaultMonitor value
	//
	public static org.omg.FT.FaultMonitor read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.FaultMonitor )istream.read_Object( org.omg.FT._FaultMonitorStub.class );
	}

	//
	// Write FaultMonitor into a marshalled stream
	// @param	ostream the output stream
	// @param	value FaultMonitor value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FaultMonitor value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to FaultMonitor
	// @param	obj the CORBA Object
	// @return FaultMonitor Object
	//
	public static FaultMonitor narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof FaultMonitor )
			return ( FaultMonitor)obj;

		if ( obj._is_a( id() ) )
		{
			_FaultMonitorStub stub = new _FaultMonitorStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to FaultMonitor
	// @param	obj the CORBA Object
	// @return FaultMonitor Object
	//
	public static FaultMonitor unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof FaultMonitor )
			return ( FaultMonitor)obj;

		_FaultMonitorStub stub = new _FaultMonitorStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
