package org.omg.FT;

//
// Helper class for : FaultNotifier
//
// @author OpenORB Compiler
//
public class FaultNotifierHelper
{
	//
	// Insert FaultNotifier into an any
	// @param	a an any
	// @param	t FaultNotifier value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FaultNotifier t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract FaultNotifier from an any
	// @param	a an any
	// @return the extracted FaultNotifier value
	//
	public static org.omg.FT.FaultNotifier extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.FaultNotifierHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the FaultNotifier TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"FaultNotifier");
		}
		return _tc;
	}

	//
	// Return the FaultNotifier IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FaultNotifier:1.0";

	//
	// Read FaultNotifier from a marshalled stream
	// @param	istream the input stream
	// @return the readed FaultNotifier value
	//
	public static org.omg.FT.FaultNotifier read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.FaultNotifier )istream.read_Object( org.omg.FT._FaultNotifierStub.class );
	}

	//
	// Write FaultNotifier into a marshalled stream
	// @param	ostream the output stream
	// @param	value FaultNotifier value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FaultNotifier value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to FaultNotifier
	// @param	obj the CORBA Object
	// @return FaultNotifier Object
	//
	public static FaultNotifier narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof FaultNotifier )
			return ( FaultNotifier)obj;

		if ( obj._is_a( id() ) )
		{
			_FaultNotifierStub stub = new _FaultNotifierStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to FaultNotifier
	// @param	obj the CORBA Object
	// @return FaultNotifier Object
	//
	public static FaultNotifier unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof FaultNotifier )
			return ( FaultNotifier)obj;

		_FaultNotifierStub stub = new _FaultNotifierStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
