package org.omg.FT;

//
// Interface definition : GatewayForActiveRepl
//
// @author OpenORB Compiler
//
public abstract class GatewayForActiveReplPOA extends org.omg.PortableServer.Servant
		implements GatewayForActiveReplOperations, org.omg.CORBA.portable.InvokeHandler
{
	public GatewayForActiveRepl _this()
	{
		return GatewayForActiveReplHelper.narrow(_this_object());
	}

	public GatewayForActiveRepl _this( org.omg.CORBA.ORB orb )
	{
		return GatewayForActiveReplHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/GatewayForActiveRepl:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("invoke") )
		{
			org.omg.CORBA.Object arg0_in = _is.read_Object();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();
			String arg3_in = _is.read_string();
			long arg4_in = _is.read_longlong();
			String arg5_in = _is.read_string();
			org.omg.FT.ParametersHolder arg6_inout = new org.omg.FT.ParametersHolder();
			arg6_inout.value = org.omg.FT.ParametersHelper.read(_is);
			org.omg.CORBA.TypeCode[] arg7_in = org.omg.FT.TypeCodeSeqHelper.read(_is);
			boolean arg8_in = _is.read_boolean();
			org.omg.CORBA.Any arg9_in = _is.read_any();

			org.omg.CORBA.Any _arg_result = invoke(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in, arg6_inout, arg7_in, arg8_in, arg9_in);

			_output = handler.createReply();
			_output.write_any(_arg_result);

			org.omg.FT.ParametersHelper.write(_output,arg6_inout.value);
			return _output;
		}
		else
		if ( opName.equals("init_membership") )
		{
			org.omg.FT.ObjectLocStr[] arg0_in = org.omg.FT.ObjectLocStrsHelper.read(_is);

			init_membership(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		else
		if ( opName.equals("change_membership") )
		{
			org.omg.CORBA.Object[] arg0_in = org.omg.FT.ObjectSeqHelper.read(_is);
			String[] arg1_in = org.omg.CORBA.StringSeqHelper.read(_is);

			change_membership(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		else
		if ( opName.equals("group_members") )
		{

			org.omg.CORBA.Object[] _arg_result = group_members();

			_output = handler.createReply();
			org.omg.FT.ObjectSeqHelper.write(_output,_arg_result);

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
