package org.omg.FT;

//
// Interface definition : GenericFactory
//
// @author OpenORB Compiler
//
public interface GenericFactoryOperations
{
	//
	// Operation create_object
	//
	public org.omg.CORBA.Object create_object(String type_id, org.omg.FT.Property[] the_criteria, org.omg.CORBA.AnyHolder factory_creation_id)
		throws org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.InvalidProperty, org.omg.FT.CannotMeetCriteria;

	//
	// Operation delete_object
	//
	public void delete_object(org.omg.CORBA.Any factory_creation_id)
		throws org.omg.FT.ObjectNotFound;

	//
	// Operation activate_object
	//
	public void activate_object(org.omg.CORBA.Any factory_creation_id, long group_id, boolean first_time)
		throws org.omg.FT.ObjectNotFound;

	//
	// Operation install_gateway
	//
	public void install_gateway(org.omg.CORBA.Any factory_creation_id, org.omg.CORBA.Object gateway)
		throws org.omg.FT.ObjectNotFound;

	//
	// Operation get_load
	//
	public int get_load();

	//
	// Operation add_new_type_id
	//
	public void add_new_type_id(String type_id, String class_name, String[] new_arg_class_n, java.lang.Object[] new_arg_values, org.omg.FT.MethSignStr[] methods);

	//
	// Operation remove_type_id
	//
	public void remove_type_id(String type_id);

	//
	// Operation modify_class_name_ti
	//
	public void modify_class_name_ti(String type_id, String new_class_name);

	//
	// Operation modify_class_name_ti_ctr
	//
	public void modify_class_name_ti_ctr(String type_id, String new_class_name, String[] class_names, java.lang.Object[] arg_values);

	//
	// Operation add_new_method_type_id_s
	//
	public void add_new_method_type_id_s(String type_id, org.omg.FT.MethSignStr the_method);

	//
	// Operation add_new_method_type_id_d
	//
	public void add_new_method_type_id_d(String type_id, String method_n, org.omg.CORBA.TypeCode[] par_types, org.omg.CORBA.TypeCode[] exc_types, int[] modes, char meth_type);

	//
	// Operation remove_method_type_id
	//
	public void remove_method_type_id(String type_id, String the_method);

	//
	// Operation modify_meth_type_id_add_param
	//
	public void modify_meth_type_id_add_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos);

	//
	// Operation modify_meth_type_id_add_exc
	//
	public void modify_meth_type_id_add_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos);

	//
	// Operation modify_meth_type_id_remove_param
	//
	public void modify_meth_type_id_remove_param(String type_id, String the_method, int pos);

	//
	// Operation modify_meth_type_id_remove_exc
	//
	public void modify_meth_type_id_remove_exc(String type_id, String the_method, int pos);

	//
	// Operation modify_meth_type_id_modify_param
	//
	public void modify_meth_type_id_modify_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos);

	//
	// Operation modify_meth_type_id_modify_exc
	//
	public void modify_meth_type_id_modify_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos);

	//
	// Operation modify_meth_type_id_modify_type
	//
	public void modify_meth_type_id_modify_type(String type_id, String the_method, char new_type);

}
