package org.omg.FT;

//
// Interface definition : GenericFactory
//
// @author OpenORB Compiler
//
public abstract class GenericFactoryPOA extends org.omg.PortableServer.Servant
		implements GenericFactoryOperations, org.omg.CORBA.portable.InvokeHandler
{
	public GenericFactory _this()
	{
		return GenericFactoryHelper.narrow(_this_object());
	}

	public GenericFactory _this( org.omg.CORBA.ORB orb )
	{
		return GenericFactoryHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/GenericFactory:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	private static java.util.Hashtable _ops_Hash = new java.util.Hashtable();
	static {
		_ops_Hash.put("create_object", new Integer(0) );
		_ops_Hash.put("delete_object", new Integer(4) );
		_ops_Hash.put("activate_object", new Integer(8) );
		_ops_Hash.put("install_gateway", new Integer(12) );
		_ops_Hash.put("get_load", new Integer(16) );
		_ops_Hash.put("add_new_type_id", new Integer(20) );
		_ops_Hash.put("remove_type_id", new Integer(24) );
		_ops_Hash.put("modify_class_name_ti", new Integer(28) );
		_ops_Hash.put("modify_class_name_ti_ctr", new Integer(32) );
		_ops_Hash.put("add_new_method_type_id_s", new Integer(36) );
		_ops_Hash.put("add_new_method_type_id_d", new Integer(40) );
		_ops_Hash.put("remove_method_type_id", new Integer(44) );
		_ops_Hash.put("modify_meth_type_id_add_param", new Integer(48) );
		_ops_Hash.put("modify_meth_type_id_add_exc", new Integer(52) );
		_ops_Hash.put("modify_meth_type_id_remove_param", new Integer(56) );
		_ops_Hash.put("modify_meth_type_id_remove_exc", new Integer(60) );
		_ops_Hash.put("modify_meth_type_id_modify_param", new Integer(64) );
		_ops_Hash.put("modify_meth_type_id_modify_exc", new Integer(68) );
		_ops_Hash.put("modify_meth_type_id_modify_type", new Integer(72) );
	};

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		Integer opidx = (Integer)_ops_Hash.get(opName);
		if(opidx == null)
			throw new org.omg.CORBA.BAD_OPERATION();

		switch(opidx.intValue()) {
		case 0:
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.CriteriaHelper.read(_is);
			org.omg.CORBA.AnyHolder arg2_out = new org.omg.CORBA.AnyHolder();

			try
			{
				org.omg.CORBA.Object _arg_result = create_object(arg0_in, arg1_in, arg2_out);

				_output = handler.createReply();
				_output.write_Object(_arg_result);

				org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,arg2_out.value);
			}
			catch ( org.omg.FT.NoFactory _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoFactoryHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotCreated _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotCreatedHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidCriteriaHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.CannotMeetCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.CannotMeetCriteriaHelper.write(_output,_exception);
			}
			return _output;
		}
		case 4:
		{
			org.omg.CORBA.Any arg0_in = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_is);

			try
			{
				delete_object(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 8:
		{
			org.omg.CORBA.Any arg0_in = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_is);
			long arg1_in = _is.read_longlong();
			boolean arg2_in = _is.read_boolean();

			try
			{
				activate_object(arg0_in, arg1_in, arg2_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 12:
		{
			org.omg.CORBA.Any arg0_in = _is.read_any();
			org.omg.CORBA.Object arg1_in = _is.read_Object();

			try
			{
				install_gateway(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 16:
		{

			int _arg_result = get_load();

			_output = handler.createReply();
			_output.write_long(_arg_result);

			return _output;
		}
		case 20:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			String[] arg2_in = org.omg.CORBA.StringSeqHelper.read(_is);
			java.lang.Object[] arg3_in = org.omg.FT.AbstractBaseSeqHelper.read(_is);
			org.omg.FT.MethSignStr[] arg4_in = org.omg.FT.MethSignStrsHelper.read(_is);

			add_new_type_id(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 24:
		{
			String arg0_in = _is.read_string();

			remove_type_id(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 28:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();

			modify_class_name_ti(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 32:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			String[] arg2_in = org.omg.CORBA.StringSeqHelper.read(_is);
			java.lang.Object[] arg3_in = org.omg.FT.AbstractBaseSeqHelper.read(_is);

			modify_class_name_ti_ctr(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 36:
		{
			String arg0_in = _is.read_string();
			org.omg.FT.MethSignStr arg1_in = org.omg.FT.MethSignStrHelper.read(_is);

			add_new_method_type_id_s(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 40:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode[] arg2_in = org.omg.FT.TypeCodeSeqHelper.read(_is);
			org.omg.CORBA.TypeCode[] arg3_in = org.omg.FT.TypeCodeSeqHelper.read(_is);
			int[] arg4_in = org.omg.FT.longseqHelper.read(_is);
			char arg5_in = _is.read_char();

			add_new_method_type_id_d(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 44:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();

			remove_method_type_id(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 48:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();
			int arg4_in = _is.read_long();

			modify_meth_type_id_add_param(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 52:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();

			modify_meth_type_id_add_exc(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 56:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();

			modify_meth_type_id_remove_param(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		case 60:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();

			modify_meth_type_id_remove_exc(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		case 64:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();
			int arg4_in = _is.read_long();

			modify_meth_type_id_modify_param(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 68:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();

			modify_meth_type_id_modify_exc(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 72:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			char arg2_in = _is.read_char();

			modify_meth_type_id_modify_type(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		}

		// never reached
		throw new org.omg.CORBA.INTERNAL();
	}
}
