package org.omg.FT;

//
// Interface definition : HeartbeatPolicy
//
// @author OpenORB Compiler
//
public abstract class HeartbeatPolicyPOA extends org.omg.PortableServer.Servant
		implements HeartbeatPolicyOperations, org.omg.CORBA.portable.InvokeHandler
{
	public HeartbeatPolicy _this()
	{
		return HeartbeatPolicyHelper.narrow(_this_object());
	}

	public HeartbeatPolicy _this( org.omg.CORBA.ORB orb )
	{
		return HeartbeatPolicyHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/HeartbeatPolicy:1.0", 
		"IDL:omg.org/CORBA/Policy:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("_get_heartbeat_policy_value") )
		{
			org.omg.FT.HeartbeatPolicyValue arg = heartbeat_policy_value();
			_output = handler.createReply();
			org.omg.FT.HeartbeatPolicyValueHelper.write(_output,arg);
			return _output;
		}
		else
		if ( opName.equals("_get_policy_type") )
		{
			int arg = policy_type();
			_output = handler.createReply();
			org.omg.CORBA.PolicyTypeHelper.write(_output,arg);
			return _output;
		}
		else
		if ( opName.equals("copy") )
		{

			org.omg.CORBA.Policy _arg_result = copy();

			_output = handler.createReply();
			org.omg.CORBA.PolicyHelper.write(_output,_arg_result);

			return _output;
		}
		else
		if ( opName.equals("destroy") )
		{

			destroy();

			_output = handler.createReply();

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
