package org.omg.FT;

//
// Helper class for : HeartbeatPolicyValue
//
// @author OpenORB Compiler
//
public class HeartbeatPolicyValueHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert HeartbeatPolicyValue into an any
	// @param	a an any
	// @param	t HeartbeatPolicyValue value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.HeartbeatPolicyValue t )
	{
		a.insert_Streamable( new org.omg.FT.HeartbeatPolicyValueHolder( t ));
	}

	//
	// Extract HeartbeatPolicyValue from an any
	// @param	a an any
	// @return the extracted HeartbeatPolicyValue value
	//
	public static org.omg.FT.HeartbeatPolicyValue extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.HeartbeatPolicyValueHolder)
					return ((org.omg.FT.HeartbeatPolicyValueHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.HeartbeatPolicyValueHolder h = new org.omg.FT.HeartbeatPolicyValueHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the HeartbeatPolicyValue TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "heartbeat";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "heartbeat_interval";
				_members[1].type = org.omg.TimeBase.TimeTHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "heartbeat_timeout";
				_members[2].type = org.omg.TimeBase.TimeTHelper.type();
				_tc = orb.create_struct_tc(id(),"HeartbeatPolicyValue",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the HeartbeatPolicyValue IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/HeartbeatPolicyValue:1.0";

	//
	// Read HeartbeatPolicyValue from a marshalled stream
	// @param	istream the input stream
	// @return the readed HeartbeatPolicyValue value
	//
	public static org.omg.FT.HeartbeatPolicyValue read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.HeartbeatPolicyValue new_one = new org.omg.FT.HeartbeatPolicyValue();

		new_one.heartbeat = istream.read_boolean();
		new_one.heartbeat_interval = org.omg.TimeBase.TimeTHelper.read(istream);
		new_one.heartbeat_timeout = org.omg.TimeBase.TimeTHelper.read(istream);

		return new_one;
	}

	//
	// Write HeartbeatPolicyValue into a marshalled stream
	// @param	ostream the output stream
	// @param	value HeartbeatPolicyValue value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.HeartbeatPolicyValue value )
	{
		ostream.write_boolean(value.heartbeat);
		org.omg.TimeBase.TimeTHelper.write(ostream,value.heartbeat_interval);
		org.omg.TimeBase.TimeTHelper.write(ostream,value.heartbeat_timeout);
	}

}
