package org.omg.FT;

//
// Helper class for : InvalidState
//
// @author OpenORB Compiler
//
public class InvalidStateHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert InvalidState into an any
	// @param	a an any
	// @param	t InvalidState value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.InvalidState t )
	{
		a.insert_Streamable( new org.omg.FT.InvalidStateHolder( t ));
	}

	//
	// Extract InvalidState from an any
	// @param	a an any
	// @return the extracted InvalidState value
	//
	public static org.omg.FT.InvalidState extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.InvalidStateHolder)
					return ((org.omg.FT.InvalidStateHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.InvalidStateHolder h = new org.omg.FT.InvalidStateHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the InvalidState TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[0];

				_tc = orb.create_exception_tc(id(),"InvalidState",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the InvalidState IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/InvalidState:1.0";

	//
	// Read InvalidState from a marshalled stream
	// @param	istream the input stream
	// @return the readed InvalidState value
	//
	public static org.omg.FT.InvalidState read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.InvalidState new_one = new org.omg.FT.InvalidState();

		if ( !istream.read_string().equals( id() ) )
			throw new org.omg.CORBA.MARSHAL();

		return new_one;
	}

	//
	// Write InvalidState into a marshalled stream
	// @param	ostream the output stream
	// @param	value InvalidState value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.InvalidState value )
	{
		ostream.write_string( id() );
	}

}
