package org.omg.FT;

//
// Helper class for : LogRecord
//
// @author OpenORB Compiler
//
public class LogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert LogRecord into an any
	// @param	a an any
	// @param	t LogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.LogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.LogRecordHolder( t ));
	}

	//
	// Extract LogRecord from an any
	// @param	a an any
	// @return the extracted LogRecord value
	//
	public static org.omg.FT.LogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.LogRecordHolder)
					return ((org.omg.FT.LogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.LogRecordHolder h = new org.omg.FT.LogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the LogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "target";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "the_log_record";
				_members[1].type = org.omg.FT.SomeLogRecordHelper.type();
				_tc = orb.create_struct_tc(id(),"LogRecord",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the LogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/LogRecord:1.0";

	//
	// Read LogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed LogRecord value
	//
	public static org.omg.FT.LogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.LogRecord new_one = new org.omg.FT.LogRecord();

		new_one.target = istream.read_longlong();
		new_one.the_log_record = org.omg.FT.SomeLogRecordHelper.read(istream);

		return new_one;
	}

	//
	// Write LogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value LogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.LogRecord value )
	{
		ostream.write_longlong(value.target);
		org.omg.FT.SomeLogRecordHelper.write(ostream,value.the_log_record);
	}

}
