package org.omg.FT;

//
// Helper class for : LoggingRecoveryControllerInfo
//
// @author OpenORB Compiler
//
public class LoggingRecoveryControllerInfoHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert LoggingRecoveryControllerInfo into an any
	// @param	a an any
	// @param	t LoggingRecoveryControllerInfo value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.LoggingRecoveryControllerInfo t )
	{
		a.insert_Streamable( new org.omg.FT.LoggingRecoveryControllerInfoHolder( t ));
	}

	//
	// Extract LoggingRecoveryControllerInfo from an any
	// @param	a an any
	// @return the extracted LoggingRecoveryControllerInfo value
	//
	public static org.omg.FT.LoggingRecoveryControllerInfo extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.LoggingRecoveryControllerInfoHolder)
					return ((org.omg.FT.LoggingRecoveryControllerInfoHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.LoggingRecoveryControllerInfoHolder h = new org.omg.FT.LoggingRecoveryControllerInfoHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the LoggingRecoveryControllerInfo TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "the_loggrec_c";
				_members[0].type = org.omg.FT.LoggingRecoveryControllerHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "the_location";
				_members[1].type = org.omg.FT.LocationHelper.type();
				_tc = orb.create_struct_tc(id(),"LoggingRecoveryControllerInfo",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the LoggingRecoveryControllerInfo IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/LoggingRecoveryControllerInfo:1.0";

	//
	// Read LoggingRecoveryControllerInfo from a marshalled stream
	// @param	istream the input stream
	// @return the readed LoggingRecoveryControllerInfo value
	//
	public static org.omg.FT.LoggingRecoveryControllerInfo read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.LoggingRecoveryControllerInfo new_one = new org.omg.FT.LoggingRecoveryControllerInfo();

		new_one.the_loggrec_c = org.omg.FT.LoggingRecoveryControllerHelper.read(istream);
		new_one.the_location = org.omg.FT.LocationHelper.read(istream);

		return new_one;
	}

	//
	// Write LoggingRecoveryControllerInfo into a marshalled stream
	// @param	ostream the output stream
	// @param	value LoggingRecoveryControllerInfo value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.LoggingRecoveryControllerInfo value )
	{
		org.omg.FT.LoggingRecoveryControllerHelper.write(ostream,value.the_loggrec_c);
		org.omg.FT.LocationHelper.write(ostream,value.the_location);
	}

}
