package org.omg.FT;

//
// Interface definition : LoggingRecoveryController
//
// @author OpenORB Compiler
//
public class LoggingRecoveryControllerPOATie extends LoggingRecoveryControllerPOA
{

	//
	// Private reference to implementation object
	//
	private LoggingRecoveryControllerOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public LoggingRecoveryControllerPOATie( LoggingRecoveryControllerOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public LoggingRecoveryControllerPOATie( LoggingRecoveryControllerOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public LoggingRecoveryControllerOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( LoggingRecoveryControllerOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation record_part_get_st_upd_reply
	//
	public void record_part_get_st_upd_reply(long o_id, int c_r_i, String oper)
	{
		_tie.record_part_get_st_upd_reply( o_id,  c_r_i,  oper);
	}

	//
	// Operation record_method_call_par
	//
	public org.omg.FT.ResultResultArgs record_method_call_par(long target, String operation, org.omg.Dynamic.Parameter[] arguments, String client_id, int retention_id, long expiration_time, char method_type, long time_s, boolean broadcast)
	{
		return _tie.record_method_call_par( target,  operation,  arguments,  client_id,  retention_id,  expiration_time,  method_type,  time_s,  broadcast);
	}


	//
	// Operation record_method_call_as
	//
	public org.omg.FT.ResultResultArgs record_method_call_as(long target, String operation, byte[] buff, boolean big_e, org.omg.GIOP.Version vers, String client_id, int retention_id, long expiration_time, char method_type, boolean broadcast)
	{
		return _tie.record_method_call_as( target,  operation,  buff,  big_e,  vers,  client_id,  retention_id,  expiration_time,  method_type,  broadcast);
	}

	//
	// Operation record_reply
	//
	public void record_reply(long source, String client_id, int retention_id, org.omg.CORBA.Any reply, org.omg.CORBA.Any[] reply_args, char m_t, boolean broadcast)
	{
		_tie.record_reply( source,  client_id,  retention_id,  reply,  reply_args,  m_t,  broadcast);
	}



	//
	// Operation record_reply_exc
	//
	public void record_reply_exc(long source, String client_id, int retention_id, char m_t)
	{
		_tie.record_reply_exc( source,  client_id,  retention_id,  m_t);
	}

	//
	// Operation react_set_st_upd_reply
	//
	public void react_set_st_upd_reply(long o_i)
	{
		_tie.react_set_st_upd_reply( o_i);
	}

	//
	// Operation call_reply
	//
	public org.omg.FT.ResultResultArgs call_reply(long target, String client_id, int retention_id)
	{
		return _tie.call_reply( target,  client_id,  retention_id);
	}

	//
	// Operation request_reply
	//
	public org.omg.FT.ResultResultArgs request_reply(String cl_id, int retention_id, org.omg.CORBA.Object to)
	{
		return _tie.request_reply( cl_id,  retention_id,  to);
	}

	//
	// Operation record_request_repl
	//
	public void record_request_repl(String cl_id, org.omg.CORBA.Object to, String operation, org.omg.CORBA.Any[] arguments, int retention_id, org.omg.CORBA.Any reply)
	{
		_tie.record_request_repl( cl_id,  to,  operation,  arguments,  retention_id,  reply);
	}

	//
	// Operation record_reply_stateless
	//
	public void record_reply_stateless(long o_i, String cl_id, int ret_id, long exp_time, org.omg.CORBA.Any repl, org.omg.CORBA.Any[] repls)
	{
		_tie.record_reply_stateless( o_i,  cl_id,  ret_id,  exp_time,  repl,  repls);
	}

	//
	// Operation do_checkpointing
	//
	public void do_checkpointing(org.omg.FT.Checkpointable checkpointed_obj, long obj_id, long checkpoint_interval, org.omg.FT.Checkpointable[] transfer_to, boolean transfer, boolean periodic)
	{
		_tie.do_checkpointing( checkpointed_obj,  obj_id,  checkpoint_interval,  transfer_to,  transfer,  periodic);
	}

	//
	// Operation stop_checkpointing
	//
	public void stop_checkpointing(org.omg.FT.Checkpointable ch_o)
	{
		_tie.stop_checkpointing( ch_o);
	}

	//
	// Operation do_updating
	//
	public void do_updating(org.omg.FT.Updateable updated_obj, long obj_id, long update_interval, org.omg.FT.Updateable[] transfer_to, boolean transfer, boolean periodic)
	{
		_tie.do_updating( updated_obj,  obj_id,  update_interval,  transfer_to,  transfer,  periodic);
	}

	//
	// Operation stop_updating
	//
	public void stop_updating(org.omg.FT.Updateable up_o)
	{
		_tie.stop_updating( up_o);
	}

	//
	// Operation set_neighbours
	//
	public void set_neighbours(org.omg.FT.LoggingRecoveryController[] rm)
	{
		_tie.set_neighbours( rm);
	}

	//
	// Operation replay_last_requests
	//
	public void replay_last_requests(org.omg.CORBA.Object stub, org.omg.FT.LogRecord[] l_r, long objI, int crt_ret_id, int repl_s)
	{
		_tie.replay_last_requests( stub,  l_r,  objI,  crt_ret_id,  repl_s);
	}

	//
	// Operation record_replies
	//
	public void record_replies(org.omg.FT.LogRecord[] r)
	{
		_tie.record_replies( r);
	}

	//
	// Operation recover_new_replica_ch
	//
	public void recover_new_replica_ch(long o_id, org.omg.FT.LoggingRecoveryController lrc, org.omg.FT.Checkpointable to_recover, int repl_s)
	{
		_tie.recover_new_replica_ch( o_id,  lrc,  to_recover,  repl_s);
	}

	//
	// Operation recover_new_replica_st_ch
	//
	public void recover_new_replica_st_ch(long o_id, org.omg.FT.LoggingRecoveryController new_lrc, org.omg.FT.Checkpointable to_recover, org.omg.FT.Checkpointable failed_obj)
	{
		_tie.recover_new_replica_st_ch( o_id,  new_lrc,  to_recover,  failed_obj);
	}

	//
	// Operation recover_new_replica_upd
	//
	public void recover_new_replica_upd(long o_id, org.omg.FT.LoggingRecoveryController lrc, org.omg.FT.Updateable to_recover, int repl_s)
	{
		_tie.recover_new_replica_upd( o_id,  lrc,  to_recover,  repl_s);
	}

	//
	// Operation remove_log
	//
	public void remove_log(long o_id)
	{
		_tie.remove_log( o_id);
	}

	//
	// Operation record_method_no_wait_par
	//
	public void record_method_no_wait_par(long objI, String oper, org.omg.Dynamic.Parameter[] args, String client_id, int retention_id, long expiration_time, char meth_type, long mess_id)
	{
		_tie.record_method_no_wait_par( objI,  oper,  args,  client_id,  retention_id,  expiration_time,  meth_type,  mess_id);
	}

	//
	// Operation record_method_no_wait_as
	//
	public void record_method_no_wait_as(long objI, String oper, byte[] buffer, boolean big_e, org.omg.GIOP.Version vers, String client_id, int retention_id, long expiration_time, char met_type, long mess_id)
	{
		_tie.record_method_no_wait_as( objI,  oper,  buffer,  big_e,  vers,  client_id,  retention_id,  expiration_time,  met_type,  mess_id);
	}

	//
	// Operation record_reply_no_notify
	//
	public void record_reply_no_notify(long objI, String client_id, int retention_id, org.omg.CORBA.Any result, org.omg.CORBA.Any[] result_arguments, char m_t)
	{
		_tie.record_reply_no_notify( objI,  client_id,  retention_id,  result,  result_arguments,  m_t);
	}

}
