package org.omg.FT;

//
// Helper class for : ObjectLocStr
//
// @author OpenORB Compiler
//
public class ObjectLocStrHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ObjectLocStr into an any
	// @param	a an any
	// @param	t ObjectLocStr value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.ObjectLocStr t )
	{
		a.insert_Streamable( new org.omg.FT.ObjectLocStrHolder( t ));
	}

	//
	// Extract ObjectLocStr from an any
	// @param	a an any
	// @return the extracted ObjectLocStr value
	//
	public static org.omg.FT.ObjectLocStr extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.ObjectLocStrHolder)
					return ((org.omg.FT.ObjectLocStrHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.ObjectLocStrHolder h = new org.omg.FT.ObjectLocStrHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ObjectLocStr TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "object";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_objref);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "location";
				_members[1].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_tc = orb.create_struct_tc(id(),"ObjectLocStr",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ObjectLocStr IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ObjectLocStr:1.0";

	//
	// Read ObjectLocStr from a marshalled stream
	// @param	istream the input stream
	// @return the readed ObjectLocStr value
	//
	public static org.omg.FT.ObjectLocStr read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.ObjectLocStr new_one = new org.omg.FT.ObjectLocStr();

		new_one.object = istream.read_Object();
		new_one.location = istream.read_string();

		return new_one;
	}

	//
	// Write ObjectLocStr into a marshalled stream
	// @param	ostream the output stream
	// @param	value ObjectLocStr value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.ObjectLocStr value )
	{
		ostream.write_Object(value.object);
		ostream.write_string(value.location);
	}

}
