package org.omg.FT;

//
// Helper class for : ObjectSeq
//
// @author OpenORB Compiler
//
public class ObjectSeqHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert ObjectSeq into an any
	// @param	a an any
	// @param	t ObjectSeq value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.CORBA.Object[] t )
	{
		a.insert_Streamable( new org.omg.FT.ObjectSeqHolder( t ));
	}

	//
	// Extract ObjectSeq from an any
	// @param	a an any
	// @return the extracted ObjectSeq value
	//
	public static org.omg.CORBA.Object[] extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.ObjectSeqHolder)
					return ((org.omg.FT.ObjectSeqHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.ObjectSeqHolder h = new org.omg.FT.ObjectSeqHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the ObjectSeq TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"ObjectSeq",orb.create_sequence_tc(0,orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_objref)));
		}
		return _tc;
	}

	//
	// Return the ObjectSeq IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/ObjectSeq:1.0";

	//
	// Read ObjectSeq from a marshalled stream
	// @param	istream the input stream
	// @return the readed ObjectSeq value
	//
	public static org.omg.CORBA.Object[] read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.CORBA.Object[] new_one;
		{
		int size1 = istream.read_ulong();
		new_one = new org.omg.CORBA.Object[size1];
		for ( int i1=0; i1<new_one.length; i1++)
		 {
			new_one[i1] = istream.read_Object();

		 }
		}

		return new_one;
	}

	//
	// Write ObjectSeq into a marshalled stream
	// @param	ostream the output stream
	// @param	value ObjectSeq value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.CORBA.Object[] value )
	{
		ostream.write_ulong(value.length);
		for ( int i1=0; i1<value.length; i1++)
		{
			ostream.write_Object(value[i1]);

		}
	}

}
