package org.omg.FT;

//
// Helper class for : Property
//
// @author OpenORB Compiler
//
public class PropertyHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert Property into an any
	// @param	a an any
	// @param	t Property value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.Property t )
	{
		a.insert_Streamable( new org.omg.FT.PropertyHolder( t ));
	}

	//
	// Extract Property from an any
	// @param	a an any
	// @return the extracted Property value
	//
	public static org.omg.FT.Property extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.PropertyHolder)
					return ((org.omg.FT.PropertyHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.PropertyHolder h = new org.omg.FT.PropertyHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the Property TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "nam";
				_members[0].type = org.omg.FT.NameHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "val";
				_members[1].type = org.omg.FT.ValueHelper.type();
				_tc = orb.create_struct_tc(id(),"Property",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the Property IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/Property:1.0";

	//
	// Read Property from a marshalled stream
	// @param	istream the input stream
	// @return the readed Property value
	//
	public static org.omg.FT.Property read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.Property new_one = new org.omg.FT.Property();

		new_one.nam = org.omg.FT.NameHelper.read(istream);
		new_one.val = org.omg.FT.ValueHelper.read(istream);

		return new_one;
	}

	//
	// Write Property into a marshalled stream
	// @param	ostream the output stream
	// @param	value Property value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.Property value )
	{
		org.omg.FT.NameHelper.write(ostream,value.nam);
		org.omg.FT.ValueHelper.write(ostream,value.val);
	}

}
