package org.omg.FT;

//
// Interface definition : PropertyManager
//
// @author OpenORB Compiler
//
public interface PropertyManagerOperations
{
	//
	// Operation set_default_properties
	//
	public void set_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty;

	//
	// Operation get_default_properties
	//
	public org.omg.FT.Property[] get_default_properties();

	//
	// Operation remove_default_properties
	//
	public void remove_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty;

	//
	// Operation set_type_properties
	//
	public void set_type_properties(String type_id, org.omg.FT.Property[] overrides)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty;

	//
	// Operation get_type_properties
	//
	public org.omg.FT.Property[] get_type_properties(String type_id);

	//
	// Operation remove_type_properties
	//
	public void remove_type_properties(String type_id, org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty;

	//
	// Operation set_properties_dynamically
	//
	public void set_properties_dynamically(org.omg.CORBA.Object object_group, org.omg.FT.Property[] overrides)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty;

	//
	// Operation get_properties
	//
	public org.omg.FT.Property[] get_properties(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound;

}
