package org.omg.FT;

//
// Helper class for : PullMonitorable
//
// @author OpenORB Compiler
//
public class PullMonitorableHelper
{
	//
	// Insert PullMonitorable into an any
	// @param	a an any
	// @param	t PullMonitorable value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.PullMonitorable t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract PullMonitorable from an any
	// @param	a an any
	// @return the extracted PullMonitorable value
	//
	public static org.omg.FT.PullMonitorable extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.PullMonitorableHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the PullMonitorable TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"PullMonitorable");
		}
		return _tc;
	}

	//
	// Return the PullMonitorable IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/PullMonitorable:1.0";

	//
	// Read PullMonitorable from a marshalled stream
	// @param	istream the input stream
	// @return the readed PullMonitorable value
	//
	public static org.omg.FT.PullMonitorable read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.PullMonitorable )istream.read_Object( org.omg.FT._PullMonitorableStub.class );
	}

	//
	// Write PullMonitorable into a marshalled stream
	// @param	ostream the output stream
	// @param	value PullMonitorable value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.PullMonitorable value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to PullMonitorable
	// @param	obj the CORBA Object
	// @return PullMonitorable Object
	//
	public static PullMonitorable narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof PullMonitorable )
			return ( PullMonitorable)obj;

		if ( obj._is_a( id() ) )
		{
			_PullMonitorableStub stub = new _PullMonitorableStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to PullMonitorable
	// @param	obj the CORBA Object
	// @return PullMonitorable Object
	//
	public static PullMonitorable unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof PullMonitorable )
			return ( PullMonitorable)obj;

		_PullMonitorableStub stub = new _PullMonitorableStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
