package org.omg.FT;

//
// Helper class for : RequestDurationPolicy
//
// @author OpenORB Compiler
//
public class RequestDurationPolicyHelper
{
	//
	// Insert RequestDurationPolicy into an any
	// @param	a an any
	// @param	t RequestDurationPolicy value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.RequestDurationPolicy t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract RequestDurationPolicy from an any
	// @param	a an any
	// @return the extracted RequestDurationPolicy value
	//
	public static org.omg.FT.RequestDurationPolicy extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.RequestDurationPolicyHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the RequestDurationPolicy TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"RequestDurationPolicy");
		}
		return _tc;
	}

	//
	// Return the RequestDurationPolicy IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/RequestDurationPolicy:1.0";

	//
	// Read RequestDurationPolicy from a marshalled stream
	// @param	istream the input stream
	// @return the readed RequestDurationPolicy value
	//
	public static org.omg.FT.RequestDurationPolicy read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.RequestDurationPolicy )istream.read_Object( org.omg.FT._RequestDurationPolicyStub.class );
	}

	//
	// Write RequestDurationPolicy into a marshalled stream
	// @param	ostream the output stream
	// @param	value RequestDurationPolicy value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.RequestDurationPolicy value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to RequestDurationPolicy
	// @param	obj the CORBA Object
	// @return RequestDurationPolicy Object
	//
	public static RequestDurationPolicy narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof RequestDurationPolicy )
			return ( RequestDurationPolicy)obj;

		if ( obj._is_a( id() ) )
		{
			_RequestDurationPolicyStub stub = new _RequestDurationPolicyStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to RequestDurationPolicy
	// @param	obj the CORBA Object
	// @return RequestDurationPolicy Object
	//
	public static RequestDurationPolicy unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof RequestDurationPolicy )
			return ( RequestDurationPolicy)obj;

		_RequestDurationPolicyStub stub = new _RequestDurationPolicyStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
