package org.omg.FT;

//
// Helper class for : RequestLogRecord
//
// @author OpenORB Compiler
//
public class RequestLogRecordHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert RequestLogRecord into an any
	// @param	a an any
	// @param	t RequestLogRecord value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.RequestLogRecord t )
	{
		a.insert_Streamable( new org.omg.FT.RequestLogRecordHolder( t ));
	}

	//
	// Extract RequestLogRecord from an any
	// @param	a an any
	// @return the extracted RequestLogRecord value
	//
	public static org.omg.FT.RequestLogRecord extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.RequestLogRecordHolder)
					return ((org.omg.FT.RequestLogRecordHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.RequestLogRecordHolder h = new org.omg.FT.RequestLogRecordHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the RequestLogRecord TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[4];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "operation";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "client_id";
				_members[1].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "retention_id";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "server";
				_members[3].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_objref);
				_tc = orb.create_struct_tc(id(),"RequestLogRecord",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the RequestLogRecord IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/RequestLogRecord:1.0";

	//
	// Read RequestLogRecord from a marshalled stream
	// @param	istream the input stream
	// @return the readed RequestLogRecord value
	//
	public static org.omg.FT.RequestLogRecord read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.RequestLogRecord new_one = new org.omg.FT.RequestLogRecord();

		new_one.operation = istream.read_string();
		new_one.client_id = istream.read_string();
		new_one.retention_id = istream.read_long();
		new_one.server = istream.read_Object();

		return new_one;
	}

	//
	// Write RequestLogRecord into a marshalled stream
	// @param	ostream the output stream
	// @param	value RequestLogRecord value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.RequestLogRecord value )
	{
		ostream.write_string(value.operation);
		ostream.write_string(value.client_id);
		ostream.write_long(value.retention_id);
		ostream.write_Object(value.server);
	}

}
