package org.omg.FT;

//
// Helper class for : TagFTHeartbeatEnabledTaggedComponent
//
// @author OpenORB Compiler
//
public class TagFTHeartbeatEnabledTaggedComponentHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert TagFTHeartbeatEnabledTaggedComponent into an any
	// @param	a an any
	// @param	t TagFTHeartbeatEnabledTaggedComponent value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.TagFTHeartbeatEnabledTaggedComponent t )
	{
		a.insert_Streamable( new org.omg.FT.TagFTHeartbeatEnabledTaggedComponentHolder( t ));
	}

	//
	// Extract TagFTHeartbeatEnabledTaggedComponent from an any
	// @param	a an any
	// @return the extracted TagFTHeartbeatEnabledTaggedComponent value
	//
	public static org.omg.FT.TagFTHeartbeatEnabledTaggedComponent extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.TagFTHeartbeatEnabledTaggedComponentHolder)
					return ((org.omg.FT.TagFTHeartbeatEnabledTaggedComponentHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.TagFTHeartbeatEnabledTaggedComponentHolder h = new org.omg.FT.TagFTHeartbeatEnabledTaggedComponentHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the TagFTHeartbeatEnabledTaggedComponent TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[1];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "heartbeat_enabled";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
				_tc = orb.create_struct_tc(id(),"TagFTHeartbeatEnabledTaggedComponent",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the TagFTHeartbeatEnabledTaggedComponent IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/TagFTHeartbeatEnabledTaggedComponent:1.0";

	//
	// Read TagFTHeartbeatEnabledTaggedComponent from a marshalled stream
	// @param	istream the input stream
	// @return the readed TagFTHeartbeatEnabledTaggedComponent value
	//
	public static org.omg.FT.TagFTHeartbeatEnabledTaggedComponent read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.TagFTHeartbeatEnabledTaggedComponent new_one = new org.omg.FT.TagFTHeartbeatEnabledTaggedComponent();

		new_one.heartbeat_enabled = istream.read_boolean();

		return new_one;
	}

	//
	// Write TagFTHeartbeatEnabledTaggedComponent into a marshalled stream
	// @param	ostream the output stream
	// @param	value TagFTHeartbeatEnabledTaggedComponent value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.TagFTHeartbeatEnabledTaggedComponent value )
	{
		ostream.write_boolean(value.heartbeat_enabled);
	}

}
