package org.omg.FT;

//
// Helper class for : Updateable
//
// @author OpenORB Compiler
//
public class UpdateableHelper
{
	//
	// Insert Updateable into an any
	// @param	a an any
	// @param	t Updateable value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.Updateable t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract Updateable from an any
	// @param	a an any
	// @return the extracted Updateable value
	//
	public static org.omg.FT.Updateable extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.omg.FT.UpdateableHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the Updateable TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"Updateable");
		}
		return _tc;
	}

	//
	// Return the Updateable IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/Updateable:1.0";

	//
	// Read Updateable from a marshalled stream
	// @param	istream the input stream
	// @return the readed Updateable value
	//
	public static org.omg.FT.Updateable read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.omg.FT.Updateable )istream.read_Object( org.omg.FT._UpdateableStub.class );
	}

	//
	// Write Updateable into a marshalled stream
	// @param	ostream the output stream
	// @param	value Updateable value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.Updateable value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to Updateable
	// @param	obj the CORBA Object
	// @return Updateable Object
	//
	public static Updateable narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Updateable )
			return ( Updateable)obj;

		if ( obj._is_a( id() ) )
		{
			_UpdateableStub stub = new _UpdateableStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to Updateable
	// @param	obj the CORBA Object
	// @return Updateable Object
	//
	public static Updateable unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Updateable )
			return ( Updateable)obj;

		_UpdateableStub stub = new _UpdateableStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
