package org.omg.FT;

//
// Interface definition : Updateable
//
// @author OpenORB Compiler
//
public abstract class UpdateablePOA extends org.omg.PortableServer.Servant
		implements UpdateableOperations, org.omg.CORBA.portable.InvokeHandler
{
	public Updateable _this()
	{
		return UpdateableHelper.narrow(_this_object());
	}

	public Updateable _this( org.omg.CORBA.ORB orb )
	{
		return UpdateableHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/Updateable:1.0", 
		"IDL:omg.org/FT/Checkpointable:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("get_update") )
		{

			try
			{
				byte[] _arg_result = get_update();

				_output = handler.createReply();
				org.omg.FT.StateHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.NoUpdateAvailable _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoUpdateAvailableHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("set_update") )
		{
			byte[] arg0_in = org.omg.FT.StateHelper.read(_is);

			try
			{
				set_update(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidUpdate _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidUpdateHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("get_state") )
		{

			try
			{
				byte[] _arg_result = get_state();

				_output = handler.createReply();
				org.omg.FT.StateHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.NoStateAvailable _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoStateAvailableHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("set_state") )
		{
			byte[] arg0_in = org.omg.FT.StateHelper.read(_is);

			try
			{
				set_state(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidState _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidStateHelper.write(_output,_exception);
			}
			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
