package org.omg.FT;

//
// Interface definition : Updateable
//
// @author OpenORB Compiler
//
public class UpdateablePOATie extends UpdateablePOA
{

	//
	// Private reference to implementation object
	//
	private UpdateableOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public UpdateablePOATie( UpdateableOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public UpdateablePOATie( UpdateableOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public UpdateableOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( UpdateableOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation get_update
	//
	public byte[] get_update()
		throws org.omg.FT.NoUpdateAvailable
	{
		return _tie.get_update();
	}

	//
	// Operation set_update
	//
	public void set_update(byte[] s)
		throws org.omg.FT.InvalidUpdate
	{
		_tie.set_update( s);
	}

	//
	// Operation get_state
	//
	public byte[] get_state()
		throws org.omg.FT.NoStateAvailable
	{
		return _tie.get_state();
	}

	//
	// Operation set_state
	//
	public void set_state(byte[] s)
		throws org.omg.FT.InvalidState
	{
		_tie.set_state( s);
	}

}
