package org.omg.FT;

//
// Interface definition : Checkpointable
//
// @author OpenORB Compiler
//
public class _CheckpointableStub extends org.omg.CORBA.portable.ObjectImpl
		implements Checkpointable
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/Checkpointable:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.CheckpointableOperations.class;

	//
	// Operation get_state
	//
	public byte[] get_state()
		throws org.omg.FT.NoStateAvailable
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_state",true);
					_input = this._invoke(_output);
					byte[] _arg_ret = org.omg.FT.StateHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.NoStateAvailableHelper.id()) )
					{
						throw org.omg.FT.NoStateAvailableHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_state",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.CheckpointableOperations _self = ( org.omg.FT.CheckpointableOperations ) _so.servant;
				try
				{
					return _self.get_state();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}



	//
	// Operation set_state
	//
	public void set_state(byte[] s)
		throws org.omg.FT.InvalidState
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_state",true);
					org.omg.FT.StateHelper.write(_output,s);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidStateHelper.id()) )
					{
						throw org.omg.FT.InvalidStateHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_state",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.CheckpointableOperations _self = ( org.omg.FT.CheckpointableOperations ) _so.servant;
				try
				{
					_self.set_state( s);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
