package org.omg.FT;

//
// Interface definition : FaultMonitor
//
// @author OpenORB Compiler
//
public class _FaultMonitorStub extends org.omg.CORBA.portable.ObjectImpl
		implements FaultMonitor
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/FaultMonitor:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.FaultMonitorOperations.class;

	//
	// Operation do_monitor
	//
	public void do_monitor(org.omg.FT.PullMonitorable obj, long o_g_id, int f_m_gran, org.omg.FT.FaultMonitoringIntervalAndTimeoutValue fmiv)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("do_monitor",false);
					org.omg.FT.PullMonitorableHelper.write(_output,obj);
					_output.write_longlong(o_g_id);
					_output.write_long(f_m_gran);
					org.omg.FT.FaultMonitoringIntervalAndTimeoutValueHelper.write(_output,fmiv);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("do_monitor",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultMonitorOperations _self = ( org.omg.FT.FaultMonitorOperations ) _so.servant;
				try
				{
					_self.do_monitor( obj,  o_g_id,  f_m_gran,  fmiv);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation stop_monitor
	//
	public void stop_monitor(org.omg.CORBA.Object obj)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("stop_monitor",false);
					_output.write_Object(obj);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("stop_monitor",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultMonitorOperations _self = ( org.omg.FT.FaultMonitorOperations ) _so.servant;
				try
				{
					_self.stop_monitor( obj);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
