package org.omg.FT;

//
// Interface definition : FaultNotifier
//
// @author OpenORB Compiler
//
public class _FaultNotifierStub extends org.omg.CORBA.portable.ObjectImpl
		implements FaultNotifier
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/FaultNotifier:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.FaultNotifierOperations.class;

	//
	// Operation push_structured_fault
	//
	public void push_structured_fault(org.omg.CosNotification.StructuredEvent event)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("push_structured_fault",true);
					org.omg.CosNotification.StructuredEventHelper.write(_output,event);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("push_structured_fault",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					_self.push_structured_fault( event);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation push_sequence_fault
	//
	public void push_sequence_fault(org.omg.CosNotification.StructuredEvent[] events)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("push_sequence_fault",true);
					org.omg.CosNotification.EventBatchHelper.write(_output,events);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("push_sequence_fault",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					_self.push_sequence_fault( events);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation create_subscription_filter
	//
	public org.omg.CosNotifyFilter.Filter create_subscription_filter(String constraint_grammar)
		throws org.omg.CosNotifyFilter.InvalidGrammar
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("create_subscription_filter",true);
					_output.write_string(constraint_grammar);
					_input = this._invoke(_output);
					org.omg.CosNotifyFilter.Filter _arg_ret = org.omg.CosNotifyFilter.FilterHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosNotifyFilter.InvalidGrammarHelper.id()) )
					{
						throw org.omg.CosNotifyFilter.InvalidGrammarHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("create_subscription_filter",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					return _self.create_subscription_filter( constraint_grammar);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation connect_structured_fault_consumer
	//
	public long connect_structured_fault_consumer(org.omg.CosNotifyComm.StructuredPushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("connect_structured_fault_consumer",true);
					org.omg.CosNotifyComm.StructuredPushConsumerHelper.write(_output,push_consumer);
					org.omg.CosNotifyFilter.FilterHelper.write(_output,filter);
					_input = this._invoke(_output);
					long _arg_ret = org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("connect_structured_fault_consumer",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					return _self.connect_structured_fault_consumer( push_consumer,  filter);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation connect_sequence_fault_consumer
	//
	public long connect_sequence_fault_consumer(org.omg.CosNotifyComm.SequencePushConsumer push_consumer, org.omg.CosNotifyFilter.Filter filter)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("connect_sequence_fault_consumer",true);
					org.omg.CosNotifyComm.SequencePushConsumerHelper.write(_output,push_consumer);
					org.omg.CosNotifyFilter.FilterHelper.write(_output,filter);
					_input = this._invoke(_output);
					long _arg_ret = org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("connect_sequence_fault_consumer",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					return _self.connect_sequence_fault_consumer( push_consumer,  filter);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation disconnect_consumer
	//
	public void disconnect_consumer(long connection)
		throws org.omg.CosEventComm.Disconnected
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("disconnect_consumer",true);
					org.omg.FT.FaultNotifierPackage.ConsumerIdHelper.write(_output,connection);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosEventComm.DisconnectedHelper.id()) )
					{
						throw org.omg.CosEventComm.DisconnectedHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("disconnect_consumer",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.FaultNotifierOperations _self = ( org.omg.FT.FaultNotifierOperations ) _so.servant;
				try
				{
					_self.disconnect_consumer( connection);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
