package org.omg.FT;

//
// Interface definition : GatewayForActiveRepl
//
// @author OpenORB Compiler
//
public class _GatewayForActiveReplStub extends org.omg.CORBA.portable.ObjectImpl
		implements GatewayForActiveRepl
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/GatewayForActiveRepl:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.GatewayForActiveReplOperations.class;

	//
	// Operation invoke
	//
	public org.omg.CORBA.Any invoke(org.omg.CORBA.Object target, String type_id, int ret_id, String client_id, long req_start_time, String oper, org.omg.FT.ParametersHolder args, org.omg.CORBA.TypeCode[] exc, boolean resp_exp, org.omg.CORBA.Any result)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("invoke",true);
					_output.write_Object(target);
					_output.write_string(type_id);
					_output.write_long(ret_id);
					_output.write_string(client_id);
					_output.write_longlong(req_start_time);
					_output.write_string(oper);
					org.omg.FT.ParametersHelper.write(_output,args.value);
					org.omg.FT.TypeCodeSeqHelper.write(_output,exc);
					_output.write_boolean(resp_exp);
					_output.write_any(result);
					_input = this._invoke(_output);
					org.omg.CORBA.Any _arg_ret = _input.read_any();
					args.value = org.omg.FT.ParametersHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("invoke",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GatewayForActiveReplOperations _self = ( org.omg.FT.GatewayForActiveReplOperations ) _so.servant;
				try
				{
					return _self.invoke( target,  type_id,  ret_id,  client_id,  req_start_time,  oper,  args,  exc,  resp_exp,  result);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation init_membership
	//
	public void init_membership(org.omg.FT.ObjectLocStr[] members)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("init_membership",true);
					org.omg.FT.ObjectLocStrsHelper.write(_output,members);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("init_membership",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GatewayForActiveReplOperations _self = ( org.omg.FT.GatewayForActiveReplOperations ) _so.servant;
				try
				{
					_self.init_membership( members);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation change_membership
	//
	public void change_membership(org.omg.CORBA.Object[] new_memb, String[] location)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("change_membership",true);
					org.omg.FT.ObjectSeqHelper.write(_output,new_memb);
					org.omg.CORBA.StringSeqHelper.write(_output,location);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("change_membership",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GatewayForActiveReplOperations _self = ( org.omg.FT.GatewayForActiveReplOperations ) _so.servant;
				try
				{
					_self.change_membership( new_memb,  location);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation group_members
	//
	public org.omg.CORBA.Object[] group_members()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("group_members",true);
					_input = this._invoke(_output);
					org.omg.CORBA.Object[] _arg_ret = org.omg.FT.ObjectSeqHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("group_members",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.GatewayForActiveReplOperations _self = ( org.omg.FT.GatewayForActiveReplOperations ) _so.servant;
				try
				{
					return _self.group_members();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
