package org.omg.FT;

//
// Interface definition : ObjectGroupManager
//
// @author OpenORB Compiler
//
public class _ObjectGroupManagerStub extends org.omg.CORBA.portable.ObjectImpl
		implements ObjectGroupManager
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/ObjectGroupManager:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.ObjectGroupManagerOperations.class;

	//
	// Operation create_member
	//
	public org.omg.CORBA.Object create_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, String type_id, org.omg.FT.Property[] the_criteria)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.CannotMeetCriteria
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("create_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.CriteriaHelper.write(_output,the_criteria);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberAlreadyPresentHelper.id()) )
					{
						throw org.omg.FT.MemberAlreadyPresentHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.NoFactoryHelper.id()) )
					{
						throw org.omg.FT.NoFactoryHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotCreatedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotCreatedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidCriteriaHelper.id()) )
					{
						throw org.omg.FT.InvalidCriteriaHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.CannotMeetCriteriaHelper.id()) )
					{
						throw org.omg.FT.CannotMeetCriteriaHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("create_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.create_member( object_group,  the_location,  type_id,  the_criteria);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation add_member
	//
	public org.omg.CORBA.Object add_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, org.omg.CORBA.Object member)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.ObjectNotAdded
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("add_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_output.write_Object(member);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberAlreadyPresentHelper.id()) )
					{
						throw org.omg.FT.MemberAlreadyPresentHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.ObjectNotAddedHelper.id()) )
					{
						throw org.omg.FT.ObjectNotAddedHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("add_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.add_member( object_group,  the_location,  member);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_member
	//
	public org.omg.CORBA.Object remove_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.remove_member( object_group,  the_location);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_primary_member
	//
	public org.omg.CORBA.Object set_primary_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound, org.omg.FT.PrimaryNotSet, org.omg.FT.BadReplicationStyle
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_primary_member",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,the_location);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.PrimaryNotSetHelper.id()) )
					{
						throw org.omg.FT.PrimaryNotSetHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.BadReplicationStyleHelper.id()) )
					{
						throw org.omg.FT.BadReplicationStyleHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_primary_member",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.set_primary_member( object_group,  the_location);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation locations_of_members
	//
	public org.omg.CosNaming.NameComponent[][] locations_of_members(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("locations_of_members",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.CosNaming.NameComponent[][] _arg_ret = org.omg.FT.LocationsHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("locations_of_members",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.locations_of_members( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_object_group_id
	//
	public long get_object_group_id(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_object_group_id",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					long _arg_ret = org.omg.FT.ObjectGroupIdHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_object_group_id",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_object_group_id( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_object_group_ref
	//
	public org.omg.CORBA.Object get_object_group_ref(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_object_group_ref",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_object_group_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_object_group_ref( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_group_ref
	//
	public org.omg.CORBA.Object get_group_ref(long group_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_group_ref",true);
					org.omg.FT.ObjectGroupIdHelper.write(_output,group_id);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = org.omg.FT.ObjectGroupHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_group_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_group_ref( group_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_member_ref
	//
	public org.omg.CORBA.Object get_member_ref(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] loc)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_member_ref",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.LocationHelper.write(_output,loc);
					_input = this._invoke(_output);
					org.omg.CORBA.Object _arg_ret = _input.read_Object();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.MemberNotFoundHelper.id()) )
					{
						throw org.omg.FT.MemberNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_member_ref",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.ObjectGroupManagerOperations _self = ( org.omg.FT.ObjectGroupManagerOperations ) _so.servant;
				try
				{
					return _self.get_member_ref( object_group,  loc);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
