package org.omg.FT;

//
// Interface definition : PropertyManager
//
// @author OpenORB Compiler
//
public class _PropertyManagerStub extends org.omg.CORBA.portable.ObjectImpl
		implements PropertyManager
{
	static final String[] _ids_list =
	{
		"IDL:omg.org/FT/PropertyManager:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.omg.FT.PropertyManagerOperations.class;

	//
	// Operation set_default_properties
	//
	public void set_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_default_properties",true);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_default_properties( props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_default_properties
	//
	public org.omg.FT.Property[] get_default_properties()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_default_properties",true);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_default_properties();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_default_properties
	//
	public void remove_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_default_properties",true);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_default_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.remove_default_properties( props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_type_properties
	//
	public void set_type_properties(String type_id, org.omg.FT.Property[] overrides)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.PropertiesHelper.write(_output,overrides);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_type_properties( type_id,  overrides);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_type_properties
	//
	public org.omg.FT.Property[] get_type_properties(String type_id)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_type_properties( type_id);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove_type_properties
	//
	public void remove_type_properties(String type_id, org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove_type_properties",true);
					org.omg.FT.TypeIdHelper.write(_output,type_id);
					org.omg.FT.PropertiesHelper.write(_output,props);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove_type_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.remove_type_properties( type_id,  props);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation set_properties_dynamically
	//
	public void set_properties_dynamically(org.omg.CORBA.Object object_group, org.omg.FT.Property[] overrides)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("set_properties_dynamically",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					org.omg.FT.PropertiesHelper.write(_output,overrides);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.InvalidPropertyHelper.id()) )
					{
						throw org.omg.FT.InvalidPropertyHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.FT.UnsupportedPropertyHelper.id()) )
					{
						throw org.omg.FT.UnsupportedPropertyHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_properties_dynamically",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					_self.set_properties_dynamically( object_group,  overrides);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_properties
	//
	public org.omg.FT.Property[] get_properties(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_properties",true);
					org.omg.FT.ObjectGroupHelper.write(_output,object_group);
					_input = this._invoke(_output);
					org.omg.FT.Property[] _arg_ret = org.omg.FT.PropertiesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.FT.ObjectGroupNotFoundHelper.id()) )
					{
						throw org.omg.FT.ObjectGroupNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_properties",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.FT.PropertyManagerOperations _self = ( org.omg.FT.PropertyManagerOperations ) _so.servant;
				try
				{
					return _self.get_properties( object_group);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
