package org.omg.FT;

//
// Helper class for : record_type
//
// @author OpenORB Compiler
//
public class record_typeHelper
{
	//
	// Insert record_type into an any
	// @param	a an any
	// @param	t record_type value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.record_type t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract record_type from an any
	// @param	a an any
	// @return the extracted record_type value
	//
	public static org.omg.FT.record_type extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the record_type TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			String []_members = new String[5];
			_members[0] = "checkpoint";
			_members[1] = "call";
			_members[2] = "reply";
			_members[3] = "request";
			_members[4] = "request_reply";
			_tc = orb.create_enum_tc(id(),"record_type",_members);
		}
		return _tc;
	}

	//
	// Return the record_type IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/record_type:1.0";

	//
	// Read record_type from a marshalled stream
	// @param	istream the input stream
	// @return the readed record_type value
	//
	public static org.omg.FT.record_type read( org.omg.CORBA.portable.InputStream istream )
	{
		return record_type.from_int(istream.read_ulong());
	}

	//
	// Write record_type into a marshalled stream
	// @param	ostream the output stream
	// @param	value record_type value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.record_type value )
	{
		ostream.write_ulong(value.value());
	}

}
